# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.implicit_function import ImplicitFunction


class Annulus(ImplicitFunction):
    r"""
    Annulus - implicit function for a annulus
    
    Superclass: ImplicitFunction
    
    Annulus computes the implicit function and function gradient for
    an annulus composed of two co-axial cylinders. Annulus is a
    concrete implementation of ImplicitFunction. By default the
    Annulus is centered at the origin and the axis of rotation is along
    the y-axis. You can redefine the center and axis of rotation by
    setting the Center and Axis data members. (Note that it is also
    possible to use the superclass' ImplicitFunction transformation
    matrix if necessary to reposition by using function_value() and
    function_gradient().)
    
    @warning
    The annulus is infinite in extent. To truncate the annulus in
    modeling operations use the ImplicitBoolean in combination with
    clipping planes.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkAnnulus, obj, update, **traits)
    
    axis = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 1.0, 0.0), cols=3, desc=\
        r"""
        Set/Get the axis of the annulus. If the axis is not specified as
        a unit vector, it will be normalized. If zero-length axis vector
        is used as input to this method, it will be ignored. Default is
        the Y-axis (0, 1, 0)
        """
    )

    def _axis_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAxis,
                        self.axis)

    center = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Set/Get the annulus center. Default is (0, 0, 0).
        """
    )

    def _center_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCenter,
                        self.center)

    inner_radius = traits.Float(0.25, enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the inner annulus radius. Default is 0.25.
        """
    )

    def _inner_radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetInnerRadius,
                        self.inner_radius)

    outer_radius = traits.Float(0.5, enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the outer annulus radius. Default is 0.5.
        """
    )

    def _outer_radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOuterRadius,
                        self.outer_radius)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('axis', 'GetAxis'), ('center',
    'GetCenter'), ('inner_radius', 'GetInnerRadius'), ('outer_radius',
    'GetOuterRadius'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'axis', 'center', 'inner_radius',
    'object_name', 'outer_radius'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Annulus, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Annulus properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['axis', 'center', 'inner_radius', 'object_name',
            'outer_radius']),
            title='Edit Annulus properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Annulus properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

