# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.algorithm import Algorithm


class CellGridAlgorithm(Algorithm):
    r"""
    CellGridAlgorithm - Superclass for algorithms that produce only
    polydata as output
    
    Superclass: Algorithm
    
    CellGridAlgorithm is a convenience class to make writing
    algorithms easier. It is also designed to help transition old
    algorithms to the new pipeline architecture. There are some
    assumptions and defaults made by this class you should be aware of.
    This class defaults such that your filter will have one input port
    and one output port. If that is not the case simply change it with
    set_number_of_input_ports etc. See this class constructor for the
    default. This class also provides a fill_input_port_info method that by
    default says that all inputs will be poly_data. If that isn't the case
    then please override this method in your subclass.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellGridAlgorithm, obj, update, **traits)
    
    def _get_output(self):
        return wrap_vtk(self._vtk_obj.GetOutput())
    
    def _set_output(self, obj):
        old_val = self._get_output()
        self._wrap_call(self._vtk_obj.SetOutput, deref_vtk(obj))
        self.trait_property_changed('output', old_val, obj)
    output = traits.Property(_get_output, _set_output,
                             desc="Output of this source, i.e. the result of `get_output()`.")
    
    def get_output(self, idx=None):
        """
        get_output(self) -> CellGrid
        C++: CellGrid *get_output()
        get_output(self, __a:int) -> CellGrid
        C++: CellGrid *get_output(int)
        Get the output data object for a port on this algorithm.
        """
        if idx is None:
            return wrap_vtk(self._vtk_obj.GetOutput())
        else:
            return wrap_vtk(self._vtk_obj.GetOutput(idx))

    def set_output(self, obj):
        """
        set_output(self, d:DataObject) -> None
        C++: virtual void set_output(DataObject *d)"""
        old_val = self._get_output()
        self._wrap_call(self._vtk_obj.SetOutput, deref_vtk(obj))
        self.trait_property_changed('output', old_val, obj)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def get_input_cell_attribute_to_process(self, *args):
        """
        get_input_cell_attribute_to_process(self, idx:int, input:CellGrid)
            -> CellAttribute
        C++: CellAttribute *get_input_cell_attribute_to_process(int idx,
            CellGrid *input)
        get_input_cell_attribute_to_process(self, idx:int, input:CellGrid,
            association:int) -> CellAttribute
        C++: CellAttribute *get_input_cell_attribute_to_process(int idx,
            CellGrid *input, int &association)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GetInputCellAttributeToProcess, *my_args)
        return wrap_vtk(ret)

    def get_poly_data_input(self, *args):
        """
        get_poly_data_input(self, port:int) -> CellGrid
        C++: CellGrid *get_poly_data_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetPolyDataInput, *args)
        return wrap_vtk(ret)

    def add_input_data(self, *args):
        """
        add_input_data(self, __a:DataObject) -> None
        C++: void add_input_data(DataObject *)
        add_input_data(self, __a:int, __b:DataObject) -> None
        C++: void add_input_data(int, DataObject *)
        Assign a data object as input. Note that this method does not
        establish a pipeline connection. Use add_input_connection() to
        setup a pipeline connection.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddInputData, *my_args)
        return ret

    def set_input_attribute_to_process(self, *args):
        """
        set_input_attribute_to_process(self, idx:int, port:int,
            connection:int, name:str) -> None
        C++: virtual void set_input_attribute_to_process(int idx, int port,
            int connection, const char *name)
        Set an input cell-attribute that this algorithm will process.
        Specifically the idx-th cell-attribute for this algorithm
        (starting from 0) will be taken from the cell-grid at the
        givenport and connection and must have the given name.
        
        Note that set_input_attribute_to_process() simply invokes
        set_input_array_to_process() with a cell-centered array-name; the
        same information keys are used to mark input attributes as input
        arrays. This means that you may use para_view's existing
        array_list_domain to call set_input_array_to_process with cell-grid
        algorithms to indicate cell-attributes rather than
        AbstractArrays on CellData.
        """
        ret = self._wrap_call(self._vtk_obj.SetInputAttributeToProcess, *args)
        return ret

    def set_input_data(self, *args):
        """
        set_input_data(self, __a:DataObject) -> None
        C++: void set_input_data(DataObject *)
        set_input_data(self, __a:int, __b:DataObject) -> None
        C++: void set_input_data(int, DataObject *)
        Assign a data object as input. Note that this method does not
        establish a pipeline connection. Use set_input_connection() to
        setup a pipeline connection.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetInputData, *my_args)
        return ret

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellGridAlgorithm, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellGridAlgorithm properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name']),
            title='Edit CellGridAlgorithm properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellGridAlgorithm properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

