# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell_grid_query import CellGridQuery


class CellGridIOQuery(CellGridQuery):
    r"""
    CellGridIOQuery - Serialize/deserialize CellMetadata records.
    
    Superclass: CellGridQuery
    
    CellGridIOQuery is a concrete subclass of CellGridQuery that
    helps serialize/deserialize CellGrid objects to/from JSON.
    Specifically, it reads/writes data specific to subclasses of
    CellMetadata.
    
    @sa
    CellGridQuery
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellGridIOQuery, obj, update, **traits)
    
    def get_attribute_data(self, *args):
        """
        get_attribute_data(self) -> vtknlohmann.json
        C++: vtknlohmann::json *get_attribute_data()
        Return the JSON object that holds attribute data.
        """
        ret = self._wrap_call(self._vtk_obj.GetAttributeData, *args)
        return ret

    def get_data(self, *args):
        """
        get_data(self) -> vtknlohmann.json
        C++: vtknlohmann::json *get_data()
        Return the JSON object that is our source or target.
        """
        ret = self._wrap_call(self._vtk_obj.GetData, *args)
        return ret

    def is_serializing(self):
        """
        is_serializing(self) -> bool
        C++: bool is_serializing()
        Return true if the query is serializing cells (as opposed to
        deserializing).
        """
        ret = self._vtk_obj.IsSerializing()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellGridIOQuery, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellGridIOQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit CellGridIOQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellGridIOQuery properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

