# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class CellMetadata(Object):
    r"""
    CellMetadata - Metadata for a particular type of cell (finite
    element).
    
    Superclass: Object
    
    This is a base class for metadata on cell types held by a CellGrid
    instance (not for subclasses of Cell). A CellGrid holds one
    instance of a CellMetadata-subclass for each *type* of cell
    present in the grid.
    
    This class intentionally provides very little functionality; instead,
    it is intended to serve as a key or index into a set of registered
    responder classes which are able respond to queries about cells of
    this type. This pattern makes it possible to extend VTK with both new
    cell types and new types of queries for existing cell types.
    
    @sa CellGrid
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCellMetadata, obj, update, **traits)
    
    def _get_cell_grid(self):
        return wrap_vtk(self._vtk_obj.GetCellGrid())
    def _set_cell_grid(self, arg):
        old_val = self._get_cell_grid()
        self._wrap_call(self._vtk_obj.SetCellGrid,
                        deref_vtk(arg))
        self.trait_property_changed('cell_grid', old_val, arg)
    cell_grid = traits.Property(_get_cell_grid, _set_cell_grid, desc=\
        r"""
        Return the parent CellGrid that owns this instance (or
        nullptr).
        """
    )

    def _get_caches(self):
        return wrap_vtk(self._vtk_obj.GetCaches())
    caches = traits.Property(_get_caches, desc=\
        r"""
        Return the set of registered responder types.
        
        This method is not static on purpose; even when VTK is compiled
        as a set of static libraries, calling this method will always
        return the proper class-static member. It returns the same value
        as CellMetadata::GetResponders() but will produce the correct
        result across static-library boundaries (unlike get_responders
        above).
        """
    )

    def _get_number_of_cells(self):
        return self._vtk_obj.GetNumberOfCells()
    number_of_cells = traits.Property(_get_number_of_cells, desc=\
        r"""
        Return the number of cells of this type in the parent cell-grid
        object. Subclasses must override this method.
        """
    )

    def _get_responders(self):
        return wrap_vtk(self._vtk_obj.GetResponders())
    responders = traits.Property(_get_responders, desc=\
        r"""
        Return the set of registered responder types.
        """
    )

    def clear_responders(self):
        """
        clear_responders() -> None
        C++: static void clear_responders()
        Clear all of the registered responders.
        """
        ret = self._vtk_obj.ClearResponders()
        return ret
        

    def deep_copy(self, *args):
        """
        deep_copy(self, other:CellMetadata) -> None
        C++: virtual void deep_copy(CellMetadata *other)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.DeepCopy, *my_args)
        return ret

    def query(self, *args):
        """
        query(self, query:CellGridQuery) -> bool
        C++: bool query(CellGridQuery *query)
        Respond to a query on cells of this type.
        
        This returns true on success and false on failure. If no
        responder has been registered for queries of this type, that is
        considered a failure.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Query, *my_args)
        return ret

    def shallow_copy(self, *args):
        """
        shallow_copy(self, other:CellMetadata) -> None
        C++: virtual void shallow_copy(CellMetadata *other)
        Copy other into this instance (which must be of the same type).
        
        These methods exist so subclasses know when they are being
        copied; the base class has no data to copy, so both shallow_copy
        and deep_copy do nothing.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ShallowCopy, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CellMetadata, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CellMetadata properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit CellMetadata properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CellMetadata properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

