# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.pass_input_type_algorithm import PassInputTypeAlgorithm


class CleanArrays(PassInputTypeAlgorithm):
    r"""
    CleanArrays - filter used to remove partial arrays across
    processes.
    
    Superclass: PassInputTypeAlgorithm
    
    CleanArrays is a filter used to remove (or fill up) partial arrays
    in a DataSet (or a CompositeDataSet) across processes (and
    blocks). Empty dataset on any processes is skipped and doesn't affect
    the array pruned (or filled) in the output. This filter also handles
    certain non-composite data objects such a tables.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCleanArrays, obj, update, **traits)
    
    fill_partial_arrays = tvtk_base.false_bool_trait(desc=\
        r"""
        When set to true (false by default), 0 filled array will be added
        for missing arrays on this process (instead of removing partial
        arrays).
        """
    )

    def _fill_partial_arrays_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFillPartialArrays,
                        self.fill_partial_arrays_)

    mark_filled_partial_arrays = tvtk_base.false_bool_trait(desc=\
        r"""
        When fill_partial_arrays is true, this filter can add a
        `vtkunsigned_char_array` for each partial array to indicate which
        entries are valid and which are simply filled in with 0. To do
        that, set this flag to true. Default is false.
        """
    )

    def _mark_filled_partial_arrays_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMarkFilledPartialArrays,
                        self.mark_filled_partial_arrays_)

    def _get_controller(self):
        return wrap_vtk(self._vtk_obj.GetController())
    def _set_controller(self, arg):
        old_val = self._get_controller()
        self._wrap_call(self._vtk_obj.SetController,
                        deref_vtk(arg))
        self.trait_property_changed('controller', old_val, arg)
    controller = traits.Property(_get_controller, _set_controller, desc=\
        r"""
        
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    _updateable_traits_ = \
    (('fill_partial_arrays', 'GetFillPartialArrays'),
    ('mark_filled_partial_arrays', 'GetMarkFilledPartialArrays'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'fill_partial_arrays',
    'global_warning_display', 'mark_filled_partial_arrays',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CleanArrays, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CleanArrays properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['fill_partial_arrays', 'mark_filled_partial_arrays'], [],
            ['abort_output', 'object_name']),
            title='Edit CleanArrays properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CleanArrays properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

