# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.color_transfer_function_item import ColorTransferFunctionItem


class CompositeTransferFunctionItem(ColorTransferFunctionItem):
    r"""
    CompositeTransferFunctionItem - Plot::Color and Plot::Brush
    have no effect here.
    
    Superclass: ColorTransferFunctionItem
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCompositeTransferFunctionItem, obj, update, **traits)
    
    def _get_opacity_function(self):
        return wrap_vtk(self._vtk_obj.GetOpacityFunction())
    def _set_opacity_function(self, arg):
        old_val = self._get_opacity_function()
        self._wrap_call(self._vtk_obj.SetOpacityFunction,
                        deref_vtk(arg))
        self.trait_property_changed('opacity_function', old_val, arg)
    opacity_function = traits.Property(_get_opacity_function, _set_opacity_function, desc=\
        r"""
        
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input table used by the plot.
        """
    )

    _updateable_traits_ = \
    (('legend_visibility', 'GetLegendVisibility'), ('selectable',
    'GetSelectable'), ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('mask_above_curve', 'GetMaskAboveCurve'),
    ('user_bounds', 'GetUserBounds'), ('label', 'GetLabel'),
    ('tooltip_label_format', 'GetTooltipLabelFormat'),
    ('tooltip_notation', 'GetTooltipNotation'), ('tooltip_precision',
    'GetTooltipPrecision'), ('use_index_for_x_series',
    'GetUseIndexForXSeries'), ('width', 'GetWidth'),
    ('x_axis_input_array_to_process', 'GetXAxisInputArrayToProcess'),
    ('y_axis_input_array_to_process', 'GetYAxisInputArrayToProcess'),
    ('opacity', 'GetOpacity'), ('interactive', 'GetInteractive'),
    ('visible', 'GetVisible'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'legend_visibility',
    'selectable', 'interactive', 'label', 'mask_above_curve',
    'object_name', 'opacity', 'tooltip_label_format', 'tooltip_notation',
    'tooltip_precision', 'use_index_for_x_series', 'user_bounds',
    'visible', 'width', 'x_axis_input_array_to_process',
    'y_axis_input_array_to_process'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CompositeTransferFunctionItem, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CompositeTransferFunctionItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['legend_visibility', 'selectable'], [], ['interactive',
            'label', 'mask_above_curve', 'object_name', 'opacity',
            'tooltip_label_format', 'tooltip_notation', 'tooltip_precision',
            'use_index_for_x_series', 'user_bounds', 'visible', 'width',
            'x_axis_input_array_to_process', 'y_axis_input_array_to_process']),
            title='Edit CompositeTransferFunctionItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CompositeTransferFunctionItem properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

