# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class ContextScene(Object):
    r"""
    ContextScene - Provides a 2D scene for ContextItem objects.
    
    Superclass: Object
    
    Provides a 2D scene that ContextItem objects can be added to.
    Manages the items, ensures that they are rendered at the right times
    and passes on mouse events.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkContextScene, obj, update, **traits)
    
    scale_tiles = tvtk_base.true_bool_trait(desc=\
        r"""
        Whether to scale the scene transform when tiling, for example
        when using WindowToImageFilter to take a large screenshot. The
        default is true.
        """
    )

    def _scale_tiles_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleTiles,
                        self.scale_tiles_)

    def _get_annotation_link(self):
        return wrap_vtk(self._vtk_obj.GetAnnotationLink())
    def _set_annotation_link(self, arg):
        old_val = self._get_annotation_link()
        self._wrap_call(self._vtk_obj.SetAnnotationLink,
                        deref_vtk(arg))
        self.trait_property_changed('annotation_link', old_val, arg)
    annotation_link = traits.Property(_get_annotation_link, _set_annotation_link, desc=\
        r"""
        Get the AnnotationLink for the chart.
        """
    )

    dirty = traits.Bool(True, enter_set=True, auto_set=False, desc=\
        r"""
        Inform the scene that something changed that requires a repaint
        of the scene. This should only be used by the ContextItem
        derived objects in a scene in their event handlers.
        """
    )

    def _dirty_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetDirty,
                        self.dirty)

    geometry = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(0, 0), cols=2, desc=\
        r"""
        Set the width and height of the scene in pixels.
        """
    )

    def _geometry_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGeometry,
                        self.geometry)

    origin = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(0, 0), cols=2, desc=\
        r"""
        Get/Set the origin (bottom-left) coordinate of the scene in
        pixels (screen coordinates).
        """
    )

    def _origin_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrigin,
                        self.origin)

    def _get_renderer(self):
        return wrap_vtk(self._vtk_obj.GetRenderer())
    def _set_renderer(self, arg):
        old_val = self._get_renderer()
        self._wrap_call(self._vtk_obj.SetRenderer,
                        deref_vtk(arg))
        self.trait_property_changed('renderer', old_val, arg)
    renderer = traits.Property(_get_renderer, _set_renderer, desc=\
        r"""
        
        """
    )

    def _get_transform(self):
        return wrap_vtk(self._vtk_obj.GetTransform())
    def _set_transform(self, arg):
        old_val = self._get_transform()
        self._wrap_call(self._vtk_obj.SetTransform,
                        deref_vtk(arg))
        self.trait_property_changed('transform', old_val, arg)
    transform = traits.Property(_get_transform, _set_transform, desc=\
        r"""
        Get the transform for the scene.
        """
    )

    use_buffer_id = traits.Bool(True, enter_set=True, auto_set=False, desc=\
        r"""
        Set whether the scene should use the color buffer. Default is
        true.
        """
    )

    def _use_buffer_id_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseBufferId,
                        self.use_buffer_id)

    def _get_buffer_id(self):
        return wrap_vtk(self._vtk_obj.GetBufferId())
    buffer_id = traits.Property(_get_buffer_id, desc=\
        r"""
        Return buffer id. Not part of the end-user API. Can be used by
        context items to initialize their own colorbuffer id (when a
        context item is a container).
        """
    )

    def get_item(self, *args):
        """
        get_item(self, index:int) -> AbstractContextItem
        C++: AbstractContextItem *get_item(unsigned int index)
        Get the item at the specified index.
        \\return the item at the specified index (null if index is
            invalid).
        """
        ret = self._wrap_call(self._vtk_obj.GetItem, *args)
        return wrap_vtk(ret)

    def _get_last_painter(self):
        return wrap_vtk(self._vtk_obj.GetLastPainter())
    last_painter = traits.Property(_get_last_painter, desc=\
        r"""
        Last painter used. Not part of the end-user API. Can be used by
        context items to create their own colorbuffer id (when a context
        item is a container).
        """
    )

    def _get_logical_tile_scale(self):
        return wrap_vtk(self._vtk_obj.GetLogicalTileScale())
    logical_tile_scale = traits.Property(_get_logical_tile_scale, desc=\
        r"""
        The tile scale of the target RenderWindow. Hardcoded pixel
        offsets, etc should properly account for these <x, y> scale
        factors. This will simply return Vector2i(1, 1) if scale_tiles
        is false or if this->Renderer is NULL.
        """
    )

    def _get_number_of_items(self):
        return self._vtk_obj.GetNumberOfItems()
    number_of_items = traits.Property(_get_number_of_items, desc=\
        r"""
        Get the number of child items.
        """
    )

    def _get_picked_item(self):
        return wrap_vtk(self._vtk_obj.GetPickedItem())
    picked_item = traits.Property(_get_picked_item, desc=\
        r"""
        Return the item id under mouse cursor at position (x,y). Return
        -1 if there is no item under the mouse cursor.
        \post valid_result: result>=-1 && result<this->get_number_of_items()
        """
    )

    def get_picked_item(self, *args):
        """
        get_picked_item(self, x:int, y:int) -> int
        C++: IdType get_picked_item(int x, int y)
        get_picked_item(self) -> AbstractContextItem
        C++: AbstractContextItem *get_picked_item()
        Return the item id under mouse cursor at position (x,y). Return
        -1 if there is no item under the mouse cursor.
        \\post valid_result: result>=-1 && result<this->get_number_of_items()
        """
        ret = self._wrap_call(self._vtk_obj.GetPickedItem, *args)
        return wrap_vtk(ret)

    def _get_scene_bottom(self):
        return self._vtk_obj.GetSceneBottom()
    scene_bottom = traits.Property(_get_scene_bottom, desc=\
        r"""
        Get the bottom of the scene in screen coordinates. This is
        equivalent to get_origin[1].
        """
    )

    def _get_scene_height(self):
        return self._vtk_obj.GetSceneHeight()
    scene_height = traits.Property(_get_scene_height, desc=\
        r"""
        Get the height of the scene.
        """
    )

    def _get_scene_left(self):
        return self._vtk_obj.GetSceneLeft()
    scene_left = traits.Property(_get_scene_left, desc=\
        r"""
        Get the left of the scene in screen coordinates. This is
        equivalent to get_origin[0].
        """
    )

    def _get_scene_width(self):
        return self._vtk_obj.GetSceneWidth()
    scene_width = traits.Property(_get_scene_width, desc=\
        r"""
        Get the width of the scene.
        """
    )

    def _get_view_height(self):
        return self._vtk_obj.GetViewHeight()
    view_height = traits.Property(_get_view_height, desc=\
        r"""
        Get the height of the view (render window) containing this scene.
        Note that this might be larger than the scene height, which can
        be retrieved using the get_scene_height method, when multiple
        viewports are defined in the render window.
        """
    )

    def _get_view_width(self):
        return self._vtk_obj.GetViewWidth()
    view_width = traits.Property(_get_view_width, desc=\
        r"""
        Get the width of the view (render window) containing this scene.
        Note that this might be larger than the scene width, which can be
        retrieved using the get_scene_width method, when multiple viewports
        are defined in the render window.
        """
    )

    def add_item(self, *args):
        """
        add_item(self, item:AbstractContextItem) -> int
        C++: unsigned int add_item(AbstractContextItem *item)
        Add child items to this item. Increments reference count of item.
        \\return the index of the child item.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.AddItem, *my_args)
        return ret

    def clear_items(self):
        """
        clear_items(self) -> None
        C++: void clear_items()
        Remove all child items from this item.
        """
        ret = self._vtk_obj.ClearItems()
        return ret
        

    def has_transform(self):
        """
        has_transform(self) -> bool
        C++: bool has_transform()
        Check whether the scene has a transform.
        """
        ret = self._vtk_obj.HasTransform()
        return ret
        

    def paint(self, *args):
        """
        paint(self, painter:Context2D) -> bool
        C++: virtual bool paint(Context2D *painter)
        Paint event for the chart, called whenever the chart needs to be
        drawn
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Paint, *my_args)
        return ret

    def release_graphics_resources(self):
        """
        release_graphics_resources(self) -> None
        C++: void release_graphics_resources()
        Release graphics resources hold by the scene.
        """
        ret = self._vtk_obj.ReleaseGraphicsResources()
        return ret
        

    def remove_all_items(self):
        """
        remove_all_items(self) -> None
        C++: void remove_all_items()"""
        ret = self._vtk_obj.RemoveAllItems()
        return ret
        

    def remove_item(self, *args):
        """
        remove_item(self, item:AbstractContextItem) -> bool
        C++: bool remove_item(AbstractContextItem *item)
        remove_item(self, index:int) -> bool
        C++: bool remove_item(unsigned int index)
        Remove child item from this item. Decrements reference count of
        item.
        \\param item the item to be removed.
        \\return true on success, false otherwise.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.RemoveItem, *my_args)
        return ret

    _updateable_traits_ = \
    (('scale_tiles', 'GetScaleTiles'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('dirty',
    'GetDirty'), ('geometry', 'GetGeometry'), ('origin', 'GetOrigin'),
    ('use_buffer_id', 'GetUseBufferId'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'scale_tiles', 'dirty',
    'geometry', 'object_name', 'origin', 'use_buffer_id'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ContextScene, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ContextScene properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['scale_tiles'], [], ['dirty', 'geometry', 'object_name',
            'origin', 'use_buffer_id']),
            title='Edit ContextScene properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ContextScene properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

