# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.decimate_polyline_strategy import DecimatePolylineStrategy


class DecimatePolylineCustomFieldStrategy(DecimatePolylineStrategy):
    r"""
    DecimatePolylineCustomFieldStrategy - Decimation strategy using a
    custom point data array to retrieve the data to be used a a metric.
    
    Superclass: DecimatePolylineStrategy
    
    This class inherits from `vtkdecimate_polyline_strategy` and its
    decimation strategy uses the values stored in a defined point data
    array as a metric of error. This array is retrieved using the the
    class property field_name.
    
    @warning
    The compute_error method doesn't check the validity of its parameters
    for performance purposes. This is up to the caller to ensure the
    provided data are valid.
    
    @sa
    DecimatePolylineFilter
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkDecimatePolylineCustomFieldStrategy, obj, update, **traits)
    
    field_name = traits.String('', enter_set=True, auto_set=False, desc=\
        r"""
        The name of the field containing the decimation informations to
        evaluate. Defaults to an empty string.
        """
    )

    def _field_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFieldName,
                        self.field_name)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('field_name', 'GetFieldName'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'field_name', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(DecimatePolylineCustomFieldStrategy, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit DecimatePolylineCustomFieldStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['field_name', 'object_name']),
            title='Edit DecimatePolylineCustomFieldStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit DecimatePolylineCustomFieldStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

