# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class DecimatePolylineStrategy(Object):
    r"""
    DecimatePolylineStrategy - abstract class to define a decimation
    strategy for the DecimatePolylineFilter
    
    Superclass: Object
    
    Parent class for the polyline decimation strategies. It defines a
    pure virtual method `compute_error` that requires an implementation
    for each strategy inheriting this class. It also requires to be given
    a dataset on which it will gather the points to perform the error
    computation.
    
    @sa
    DecimatePolylineFilter, DecimatePolylineAngleStrategy,
    DecimateCustomFieldStrategy, DecimateDistanceStrategy
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkDecimatePolylineStrategy, obj, update, **traits)
    
    def compute_error(self, *args):
        """
        compute_error(self, dataset:PointSet, originId:int, p1Id:int,
            p2Id:int) -> float
        C++: virtual double compute_error(PointSet *dataset,
            IdType originId, IdType p1Id, IdType p2Id)
        Virtual method for computing the decimation error. The caller
        should ensure that the Ids provided correspond to existing and
        allocated points in the corresponding dataset.
        @param dataset the dataset containing the points to evaluate.
        @param originId the Id of the origin point.
        @param p1Id the Id of the previous point to the origin.
        @param p2Id the Id of the next point to the origin.
        @return the decimation error between the 3 consecutive points.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.ComputeError, *my_args)
        return ret

    def is_state_valid(self, *args):
        """
        is_state_valid(self, dataset:PointSet) -> bool
        C++: virtual bool is_state_valid(PointSet *dataset)
        Returns whether this decimation strategy is in
        a valid state and ready to compute errors. Subclasses are
        expected to implement this method if they need to have to ensure
        that some of their state is set correctly. Strategies in invalid
        state will cause the filter to early return. Returns `true` by
        default.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.IsStateValid, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(DecimatePolylineStrategy, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit DecimatePolylineStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit DecimatePolylineStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit DecimatePolylineStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

