# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell_attribute_information import CellAttributeInformation


class DGAttributeInformation(CellAttributeInformation):
    r"""
    DGAttributeInformation - Provide information about a cell
    attribute's basis functions on one cell type.
    
    Superclass: CellAttributeInformation
    
    Note that some of the methods may be unable to return meaningful
    information about some attribute types; this class has methods that
    may be specific to subclasses of DGCell. If this API does not fit
    your cell type or attribute type; do not register a calculator
    subclass of this type. Instead, it is up to consuming code to ensure
    a non-null calculator is returned.
    
    This calculator assumes interpolation is performed as a weighted sum
    of basis functions evaluated at some parameter value.
    
    \[
       f_j = \sum_i B_i(r) w_{i,j}\]
    
    where $i\in[0, M - 1] $ and $j\in[0,N - 1[ $. + $M $ is
    get_number_of_basis_functions(). + $N $ is
    number_of_components_per_degree_of_freedom().
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkDGAttributeInformation, obj, update, **traits)
    
    def basis_shape_name(self, *args):
        """
        basis_shape_name(cellType:DGCell) -> str
        C++: static std::string basis_shape_name(DGCell *cellType)
        Given a cell type, return an abbreviated shape name. The returned
        value will always be a valid C identifier. When cellType is null,
        the returned string will be `None`.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.BasisShapeName, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(DGAttributeInformation, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit DGAttributeInformation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit DGAttributeInformation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit DGAttributeInformation properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

