# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class ExecutionAggregator(Object):
    r"""
    ExecutionAggregator - Aggregate the results of the sub-pipeline in
    EndFor
    
    Superclass: Object
    
    ExecutionAggregator is an interface for EndFor aggregators An
    aggregator is called at the end of each loop and processes the
    resulting data object. The `get_output_data_object` should only be
    called once the iterations are done, it can be used for data
    reduction.
    
    @sa EndFor, ForEach, AggregateToPartitionedDataSetCollection
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkExecutionAggregator, obj, update, **traits)
    
    def _get_output_data_object(self):
        return wrap_vtk(self._vtk_obj.GetOutputDataObject())
    output_data_object = traits.Property(_get_output_data_object, desc=\
        r"""
        Called after the iterations are done, to retrieve the resulting
        data object. If a reduction operation is done, it should be
        implemented here.
        """
    )

    def aggregate(self, *args):
        """
        aggregate(self, input:DataObject) -> bool
        C++: virtual bool aggregate(DataObject *input)
        Called at the end of each iteration with the corresponding data
        object.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.Aggregate, *my_args)
        return ret

    def clear(self):
        """
        clear(self) -> None
        C++: virtual void clear()
        Called after the iterations are done, to clean memory that where
        used by the Aggregate method. It is called after the output has
        been retrieved
        """
        ret = self._vtk_obj.Clear()
        return ret
        

    def request_data_object(self, *args):
        """
        request_data_object(self, input:DataObject) -> DataObject
        C++: virtual SmartPointer<vtkDataObject> request_data_object(
            DataObject *input)
        Create the empty output data set. see Algorithm.h
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.RequestDataObject, *my_args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ExecutionAggregator, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ExecutionAggregator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit ExecutionAggregator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ExecutionAggregator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

