# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.generic_open_gl_render_window import GenericOpenGLRenderWindow


class ExternalOpenGLRenderWindow(GenericOpenGLRenderWindow):
    r"""
    ExternalOpenGLRenderWindow - open_gl render window that allows
    using an external window to render vtk objects
    
    Superclass: GenericOpenGLRenderWindow
    
    ExternalOpenGLRenderWindow is a concrete implementation of the
    abstract class RenderWindow. ExternalOpenGLRenderer interfaces
    to the open_gl graphics library.
    
    This class extends GenericOpenGLRenderWindow to allow sharing the
    same open_gl context by various visualization applications. Basically,
    this class prevents VTK from creating a new open_gl context. Thus, it
    requires that an open_gl context be initialized before Render is
    called.
    \sa Render()
    
    It is a generic implementation; this window is platform agnostic.
    However, the application user must explicitly make sure the window
    size is synchronized when the external application window/viewport
    resizes.
    \sa set_size()
    
    It has the same requirements as the GenericOpenGLRenderWindow,
    whereby, one must register an observer for window_make_current_event,
    window_is_current_event and window_frame_event.
    \sa GenericOpenGLRenderWindow
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkExternalOpenGLRenderWindow, obj, update, **traits)
    
    automatic_window_position_and_resize = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _automatic_window_position_and_resize_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAutomaticWindowPositionAndResize,
                        self.automatic_window_position_and_resize_)

    use_external_content = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _use_external_content_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseExternalContent,
                        self.use_external_content_)

    _updateable_traits_ = \
    (('automatic_window_position_and_resize',
    'GetAutomaticWindowPositionAndResize'), ('use_external_content',
    'GetUseExternalContent'), ('framebuffer_flip_y',
    'GetFramebufferFlipY'), ('borders', 'GetBorders'),
    ('enable_translucent_surface', 'GetEnableTranslucentSurface'),
    ('full_screen', 'GetFullScreen'), ('line_smoothing',
    'GetLineSmoothing'), ('point_smoothing', 'GetPointSmoothing'),
    ('polygon_smoothing', 'GetPolygonSmoothing'), ('stencil_capable',
    'GetStencilCapable'), ('stereo_capable_window',
    'GetStereoCapableWindow'), ('stereo_render', 'GetStereoRender'),
    ('swap_buffers', 'GetSwapBuffers'), ('use_srgb_color_space',
    'GetUseSRGBColorSpace'), ('double_buffer', 'GetDoubleBuffer'),
    ('erase', 'GetErase'), ('off_screen_rendering',
    'GetOffScreenRendering'), ('show_window', 'GetShowWindow'),
    ('use_off_screen_buffers', 'GetUseOffScreenBuffers'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('frame_blit_mode', 'GetFrameBlitMode'), ('stereo_type',
    'GetStereoType'), ('current_cursor', 'GetCurrentCursor'),
    ('force_maximum_hardware_line_width',
    'GetForceMaximumHardwareLineWidth'), ('mapped', 'GetMapped'),
    ('ready_for_rendering', 'GetReadyForRendering'), ('screen_size',
    'GetScreenSize'), ('global_maximum_number_of_multi_samples',
    'GetGlobalMaximumNumberOfMultiSamples'),
    ('render_buffer_target_depth_size', 'GetRenderBufferTargetDepthSize'),
    ('abort_render', 'GetAbortRender'), ('alpha_bit_planes',
    'GetAlphaBitPlanes'), ('anaglyph_color_mask', 'GetAnaglyphColorMask'),
    ('anaglyph_color_saturation', 'GetAnaglyphColorSaturation'),
    ('cursor_file_name', 'GetCursorFileName'), ('desired_update_rate',
    'GetDesiredUpdateRate'), ('device_index', 'GetDeviceIndex'),
    ('in_abort_check', 'GetInAbortCheck'), ('multi_samples',
    'GetMultiSamples'), ('number_of_layers', 'GetNumberOfLayers'),
    ('physical_scale', 'GetPhysicalScale'), ('physical_translation',
    'GetPhysicalTranslation'), ('physical_view_direction',
    'GetPhysicalViewDirection'), ('physical_view_up',
    'GetPhysicalViewUp'), ('dpi', 'GetDPI'), ('position', 'GetPosition'),
    ('size', 'GetSize'), ('tile_scale', 'GetTileScale'), ('tile_viewport',
    'GetTileViewport'), ('window_name', 'GetWindowName'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['automatic_window_position_and_resize', 'borders', 'debug',
    'double_buffer', 'enable_translucent_surface', 'erase',
    'framebuffer_flip_y', 'full_screen', 'global_warning_display',
    'line_smoothing', 'off_screen_rendering', 'point_smoothing',
    'polygon_smoothing', 'show_window', 'stencil_capable',
    'stereo_capable_window', 'stereo_render', 'swap_buffers',
    'use_external_content', 'use_off_screen_buffers',
    'use_srgb_color_space', 'frame_blit_mode', 'stereo_type',
    'abort_render', 'alpha_bit_planes', 'anaglyph_color_mask',
    'anaglyph_color_saturation', 'current_cursor', 'cursor_file_name',
    'desired_update_rate', 'device_index', 'dpi',
    'force_maximum_hardware_line_width',
    'global_maximum_number_of_multi_samples', 'in_abort_check', 'mapped',
    'multi_samples', 'number_of_layers', 'object_name', 'physical_scale',
    'physical_translation', 'physical_view_direction', 'physical_view_up',
    'position', 'ready_for_rendering', 'render_buffer_target_depth_size',
    'screen_size', 'size', 'tile_scale', 'tile_viewport', 'window_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ExternalOpenGLRenderWindow, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ExternalOpenGLRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['automatic_window_position_and_resize', 'borders',
            'double_buffer', 'enable_translucent_surface', 'erase',
            'framebuffer_flip_y', 'full_screen', 'line_smoothing',
            'off_screen_rendering', 'point_smoothing', 'polygon_smoothing',
            'show_window', 'stencil_capable', 'stereo_capable_window',
            'stereo_render', 'swap_buffers', 'use_external_content',
            'use_off_screen_buffers', 'use_srgb_color_space'], ['frame_blit_mode',
            'stereo_type'], ['abort_render', 'alpha_bit_planes',
            'anaglyph_color_mask', 'anaglyph_color_saturation', 'current_cursor',
            'cursor_file_name', 'desired_update_rate', 'device_index', 'dpi',
            'force_maximum_hardware_line_width',
            'global_maximum_number_of_multi_samples', 'in_abort_check', 'mapped',
            'multi_samples', 'number_of_layers', 'object_name', 'physical_scale',
            'physical_translation', 'physical_view_direction', 'physical_view_up',
            'position', 'ready_for_rendering', 'render_buffer_target_depth_size',
            'screen_size', 'size', 'tile_scale', 'tile_viewport', 'window_name']),
            title='Edit ExternalOpenGLRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ExternalOpenGLRenderWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

