# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.unstructured_grid_algorithm import UnstructuredGridAlgorithm


class GoldenBallSource(UnstructuredGridAlgorithm):
    r"""
    GoldenBallSource - Create a faceted approximation to a ball (i.e.,
    a solid sphere).
    
    Superclass: UnstructuredGridAlgorithm
    
    GoldenBallSource creates a ball (represented by tetrahedra) of
    specified radius and center. The resolution (number of points) can be
    specified and will be equal to the number of tetrahedra in the output
    approximation.
    
    The name derives from the golden angle (pi * (sqrt(5) - 1)) used to
    space points circumferentially so they are approximately equidistant
    from their neighbors. For this reason, the technique is sometimes
    called the "Fibonacci spiral," after the planar spiral shape which
    gets projected to the sphere.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkGoldenBallSource, obj, update, **traits)
    
    generate_normals = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/get whether to include "normal" vectors at each point. The
        default is to include normals. These are vectors of unit length
        which point outward from the center of the ball. The center point
        (if included) has a zero-length vector.
        """
    )

    def _generate_normals_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGenerateNormals,
                        self.generate_normals_)

    include_center_point = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/get whether to include a point at the center of the ball. The
        default is not to include the center.
        """
    )

    def _include_center_point_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetIncludeCenterPoint,
                        self.include_center_point_)

    center = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Set the center of the sphere. Default is 0,0,0.
        """
    )

    def _center_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCenter,
                        self.center)

    output_points_precision = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Set/get the desired precision for the output points.
        Algorithm::SINGLE_PRECISION - Output single-precision floating
        point. Algorithm::DOUBLE_PRECISION - Output double-precision
        floating point.
        """
    )

    def _output_points_precision_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOutputPointsPrecision,
                        self.output_points_precision)

    radius = traits.Trait(0.5, traits.Range(0.0, 1e+299, enter_set=True, auto_set=False), desc=\
        r"""
        Set radius of sphere. Default is .5.
        """
    )

    def _radius_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRadius,
                        self.radius)

    resolution = traits.Trait(20, traits.Range(4, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set the number of points used to approximate the sphere. The
        minimum is 4, the default is 20, and there is no maximum.
        """
    )

    def _resolution_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetResolution,
                        self.resolution)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)
        get_input(self) -> DataObject
        C++: DataObject *get_input()"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('generate_normals', 'GetGenerateNormals'), ('include_center_point',
    'GetIncludeCenterPoint'), ('abort_execute', 'GetAbortExecute'),
    ('release_data_flag', 'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('center',
    'GetCenter'), ('output_points_precision', 'GetOutputPointsPrecision'),
    ('radius', 'GetRadius'), ('resolution', 'GetResolution'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'generate_normals',
    'global_warning_display', 'include_center_point', 'release_data_flag',
    'abort_output', 'center', 'object_name', 'output_points_precision',
    'progress_text', 'radius', 'resolution'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(GoldenBallSource, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit GoldenBallSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['generate_normals', 'include_center_point'], [],
            ['abort_output', 'center', 'object_name', 'output_points_precision',
            'radius', 'resolution']),
            title='Edit GoldenBallSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit GoldenBallSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

