# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_non_oriented_super_cursor_light import HyperTreeGridNonOrientedSuperCursorLight


class HyperTreeGridNonOrientedMooreSuperCursorLight(HyperTreeGridNonOrientedSuperCursorLight):
    r"""
    HyperTreeGridNonOrientedMooreSuperCursorLight - Objects for
    traversal a hyper_tree_grid.
    
    Superclass: HyperTreeGridNonOrientedSuperCursorLight
    
    Objects that can perform depth traversal of a hyper tree grid, take
    into account more parameters (related to the grid structure) than the
    compact hyper tree cursor implemented in HyperTree can. This is an
    abstract class. Cursors are created by the hyper_tree_grid
    implementation.
    
    @sa
    HyperTree HyperTreeGrid
    
    @par Thanks: This class was written by Guenole Harel and
    Jacques-Bernard Lekien, 2014. This class was re-written by Philippe
    Pebay, 2016. This class was re-written and optimized by
    Jacques-Bernard Lekien, Guenole Harel and Jerome Dubois, 2018. This
    work was supported by Commissariat a l'Energie Atomique CEA, DAM,
    DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridNonOrientedMooreSuperCursorLight, obj, update, **traits)
    
    def get_corner_cursors(self, *args):
        """
        get_corner_cursors(self, __a:int, __b:int, __c:IdList) -> bool
        C++: bool get_corner_cursors(unsigned int, unsigned int,
            IdList *)
        Return the list of cursors pointing to the leaves touching a
        given corner of the cell. Return whether the considered cell is
        the owner of said corner. Used by filters HyperTreeGridContour
        and HyperTreeGridPlaneCutter.
        """
        my_args = deref_array(args, [('int', 'int', 'vtkIdList')])
        ret = self._wrap_call(self._vtk_obj.GetCornerCursors, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridNonOrientedMooreSuperCursorLight, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridNonOrientedMooreSuperCursorLight properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit HyperTreeGridNonOrientedMooreSuperCursorLight properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridNonOrientedMooreSuperCursorLight properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

