# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_algorithm import HyperTreeGridAlgorithm


class HyperTreeGridPreConfiguredSource(HyperTreeGridAlgorithm):
    r"""
    HyperTreeGridPreConfiguredSource - Helper class for generating a
    curated set of hyper_tree Grids (HTGs) for testing purposes
    
    Superclass: HyperTreeGridAlgorithm
    
    Provides a set of public methods for generating some commonly used
    HTG setups.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridPreConfiguredSource, obj, update, **traits)
    
    custom_depth = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _custom_depth_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCustomDepth,
                        self.custom_depth)

    custom_dim = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _custom_dim_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCustomDim,
                        self.custom_dim)

    custom_extent = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 1.0, 0.0, 1.0, 0.0, 1.0), cols=3, desc=\
        r"""
        
        """
    )

    def _custom_extent_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCustomExtent,
                        self.custom_extent)

    custom_factor = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _custom_factor_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCustomFactor,
                        self.custom_factor)

    custom_subdivisions = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(2, 2, 2), cols=3, desc=\
        r"""
        
        """
    )

    def _custom_subdivisions_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCustomSubdivisions,
                        self.custom_subdivisions)

    def generate_balanced(self, *args):
        """
        generate_balanced(self, HTG:HyperTreeGrid, dim:int, factor:int,
            depth:int, extent:(float, ...), subdivisions:(int, ...))
            -> None
        C++: void generate_balanced(HyperTreeGrid *HTG,
            unsigned int dim, unsigned int factor, unsigned int depth,
            const std::vector<double> &extent,
            const std::vector<unsigned int> &subdivisions)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateBalanced, *my_args)
        return ret

    def generate_balanced2depth3_branch_tree3x3x2(self, *args):
        """
        generate_balanced2depth3_branch_tree3x3x2(self, HTG:HyperTreeGrid)
             -> None
        C++: void generate_balanced2depth3_branch_tree3x3x2(
            HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateBalanced2Depth3BranchTree3x3x2, *my_args)
        return ret

    def generate_balanced3depth_quad_tree2x3(self, *args):
        """
        generate_balanced3depth_quad_tree2x3(self, HTG:HyperTreeGrid)
            -> None
        C++: void generate_balanced3depth_quad_tree2x3(HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateBalanced3DepthQuadTree2x3, *my_args)
        return ret

    def generate_balanced4_depth3_branch_tree2x2(self, *args):
        """
        generate_balanced4_depth3_branch_tree2x2(self, HTG:HyperTreeGrid)
            -> None
        C++: void generate_balanced4_depth3_branch_tree2x2(
            HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateBalanced4Depth3BranchTree2x2, *my_args)
        return ret

    def generate_custom(self, *args):
        """
        generate_custom(self, HTG:HyperTreeGrid) -> int
        C++: int generate_custom(HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateCustom, *my_args)
        return ret

    def generate_unbalanced(self, *args):
        """
        generate_unbalanced(self, HTG:HyperTreeGrid, dim:int,
            factor:int, depth:int, extent:(float, ...), subdivisions:(int,
             ...)) -> None
        C++: void generate_unbalanced(HyperTreeGrid *HTG,
            unsigned int dim, unsigned int factor, unsigned int depth,
            const std::vector<double> &extent,
            const std::vector<unsigned int> &subdivisions)
        Helper methods for generating HTGs
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateUnbalanced, *my_args)
        return ret

    def generate_unbalanced2depth3_branch_tree3x3(self, *args):
        """
        generate_unbalanced2depth3_branch_tree3x3(self, HTG:HyperTreeGrid)
             -> None
        C++: void generate_unbalanced2depth3_branch_tree3x3(
            HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateUnbalanced2Depth3BranchTree3x3, *my_args)
        return ret

    def generate_unbalanced3depth_oct_tree3x2x3(self, *args):
        """
        generate_unbalanced3depth_oct_tree3x2x3(self, HTG:HyperTreeGrid)
            -> None
        C++: void generate_unbalanced3depth_oct_tree3x2x3(
            HyperTreeGrid *HTG)"""
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateUnbalanced3DepthOctTree3x2x3, *my_args)
        return ret

    def generate_unbalanced3depth_quad_tree2x3(self, *args):
        """
        generate_unbalanced3depth_quad_tree2x3(self, HTG:HyperTreeGrid)
            -> None
        C++: void generate_unbalanced3depth_quad_tree2x3(
            HyperTreeGrid *HTG)
        Helper functions for generating the different types of HTGs
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.GenerateUnbalanced3DepthQuadTree2x3, *my_args)
        return ret

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('custom_depth', 'GetCustomDepth'), ('custom_dim', 'GetCustomDim'),
    ('custom_extent', 'GetCustomExtent'), ('custom_factor',
    'GetCustomFactor'), ('custom_subdivisions', 'GetCustomSubdivisions'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'custom_depth', 'custom_dim',
    'custom_extent', 'custom_factor', 'custom_subdivisions',
    'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridPreConfiguredSource, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridPreConfiguredSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'custom_depth', 'custom_dim',
            'custom_extent', 'custom_factor', 'custom_subdivisions',
            'object_name']),
            title='Edit HyperTreeGridPreConfiguredSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridPreConfiguredSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

