# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_algorithm import HyperTreeGridAlgorithm


class HyperTreeGridVisibleLeavesSize(HyperTreeGridAlgorithm):
    r"""
    HyperTreeGridVisibleLeavesSize - Generate a cell field equal to 1
    if the cell is a valid leaf and 0 otherwise, as well as a size field.
    
    Superclass: HyperTreeGridAlgorithm
    
    HyperTreeGridVisibleLeavesSize creates 2 distinct (double) cell
    fields. The first one, named 'valid_cell' by default, has a value of
    1.0 for leaf (non-refined) cells that are neither masked nor ghost,
    and 0.0 otherwise.
    
    The second one, named 'cell_size' by default, is set to the size
    (volume) of the cell for 3D HTGs, depending on its depth level. This
    field has a value for every cell traversed through the cursor, valid
    or not. By extension, cell_size is set to the cell area for 2D HTG and
    cell length for 1D. In practice, we ignore null size coordinates when
    computing the value.
    
    These 2 fields can be used for data aggregation or computations over
    the whole grid, ie computing the total size of a given HTG. These
    fields are implemented as implicit arrays, in order to lower the
    memory footprint of the filter.
    
    Note that the filter needs to be run again if cells are refined after
    its execution.
    
    @sa
    HyperTreeGrid HyperTreeGridAlgorithm
    
    @par Thanks: This class was originally written by Jacques-Bernard
    Lekien, 2023 This work was supported by Commissariat a l'Energie
    Atomique CEA, DAM, DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkHyperTreeGridVisibleLeavesSize, obj, update, **traits)
    
    cell_size_array_name = traits.String('CellSize', enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _cell_size_array_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCellSizeArrayName,
                        self.cell_size_array_name)

    valid_cell_array_name = traits.String('ValidCell', enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _valid_cell_array_name_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetValidCellArrayName,
                        self.valid_cell_array_name)

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('cell_size_array_name', 'GetCellSizeArrayName'),
    ('valid_cell_array_name', 'GetValidCellArrayName'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'cell_size_array_name',
    'object_name', 'progress_text', 'valid_cell_array_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(HyperTreeGridVisibleLeavesSize, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit HyperTreeGridVisibleLeavesSize properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'cell_size_array_name', 'object_name',
            'valid_cell_array_name']),
            title='Edit HyperTreeGridVisibleLeavesSize properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit HyperTreeGridVisibleLeavesSize properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

