# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell_attribute_calculator import CellAttributeCalculator


class InterpolateCalculator(CellAttributeCalculator):
    r"""
    InterpolateCalculator - Interpolate a field's value and possibly
    derivatives at a point in a cell.
    
    Superclass: CellAttributeCalculator
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkInterpolateCalculator, obj, update, **traits)
    
    def analytic_derivative(self):
        """
        analytic_derivative(self) -> bool
        C++: virtual bool analytic_derivative()
        Return true if the function has an analytic derivative.
        """
        ret = self._vtk_obj.AnalyticDerivative()
        return ret
        

    def evaluate(self, *args):
        """
        evaluate(self, cellId:int, rst:Vector3d, value:[float, ...])
            -> None
        C++: virtual void evaluate(IdType cellId,
            const Vector3d &rst, std::vector<double> &value)
        evaluate(self, cellIds:IdTypeArray, rst:DataArray,
            result:DataArray) -> None
        C++: virtual void evaluate(IdTypeArray *cellIds,
            DataArray *rst, DataArray *result)
        Subclasses must override this method to perform evaluation.
        
        You must resize value before calling Evaluate so there is enough
        space to hold the resulting value(s).
        """
        my_args = deref_array(args, [('int', 'vtkVector3d', 'tuple'), ('vtkIdTypeArray', 'vtkDataArray', 'vtkDataArray')])
        ret = self._wrap_call(self._vtk_obj.Evaluate, *my_args)
        return ret

    def evaluate_derivative(self, *args):
        """
        evaluate_derivative(self, cellId:int, rst:Vector3d,
            jacobian:[float, ...], neighborhood:float=1e-3) -> None
        C++: virtual void evaluate_derivative(IdType cellId,
            const Vector3d &rst, std::vector<double> &jacobian,
            double neighborhood=1e-3)
        evaluate_derivative(self, cellIds:IdTypeArray, rst:DataArray,
             result:DataArray) -> None
        C++: virtual void evaluate_derivative(IdTypeArray *cellIds,
            DataArray *rst, DataArray *result)
        Return the derivative of the function at rst.
        
        The derivative should be ordered as d/dx, d/dy, then d/dz.
        
        If you do not override analytic_derivative and evaluate_derivative,
        this class will approximate the derivative by perturbing along
        each axis to compute a finite difference.
        
        In the case of a non-analytic derivative, you can control the
        magnitude of the difference along each axis by passing a
        different neighborhood value.
        """
        my_args = deref_array(args, [('int', 'vtkVector3d', 'tuple', 'float'), ('vtkIdTypeArray', 'vtkDataArray', 'vtkDataArray')])
        ret = self._wrap_call(self._vtk_obj.EvaluateDerivative, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(InterpolateCalculator, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit InterpolateCalculator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit InterpolateCalculator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit InterpolateCalculator properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

