# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.ioss_reader import IOSSReader


class IOSSCellGridReader(IOSSReader):
    r"""
    IOSSCellGridReader - Reader for IOSS (Sierra IO System) that
    produces cell-grid data.
    
    Superclass: IOSSReader
    
    This reader is a subclass of IOSSReader that produces CellGrid
    objects instead of UnstructuredGrid objects inside each partition
    of its output partitioned-dataset collection.
    
    This reader ignores some of its base-class settings: +
    remove_unused_points + merge_exodus_entity_blocks
    
    @sa
    IOSSReader
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkIOSSCellGridReader, obj, update, **traits)
    
    _updateable_traits_ = \
    (('apply_displacements', 'GetApplyDisplacements'), ('caching',
    'GetCaching'), ('element_and_side_ids', 'GetElementAndSideIds'),
    ('generate_file_id', 'GetGenerateFileId'),
    ('merge_exodus_entity_blocks', 'GetMergeExodusEntityBlocks'),
    ('read_all_files_to_determine_structure',
    'GetReadAllFilesToDetermineStructure'), ('read_global_fields',
    'GetReadGlobalFields'), ('read_ids', 'GetReadIds'),
    ('read_qa_and_information_records', 'GetReadQAAndInformationRecords'),
    ('remove_unused_points', 'GetRemoveUnusedPoints'),
    ('scan_for_related_files', 'GetScanForRelatedFiles'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('database_type_override', 'GetDatabaseTypeOverride'),
    ('displacement_magnitude', 'GetDisplacementMagnitude'),
    ('field_suffix_separator', 'GetFieldSuffixSeparator'), ('file_name',
    'GetFileName'), ('file_range', 'GetFileRange'), ('file_stride',
    'GetFileStride'), ('group_numeric_vector_field_components',
    'GetGroupNumericVectorFieldComponents'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'apply_displacements', 'caching', 'debug',
    'element_and_side_ids', 'generate_file_id', 'global_warning_display',
    'merge_exodus_entity_blocks', 'read_all_files_to_determine_structure',
    'read_global_fields', 'read_ids', 'read_qa_and_information_records',
    'release_data_flag', 'remove_unused_points', 'scan_for_related_files',
    'abort_output', 'database_type_override', 'displacement_magnitude',
    'field_suffix_separator', 'file_name', 'file_range', 'file_stride',
    'group_numeric_vector_field_components', 'object_name',
    'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(IOSSCellGridReader, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit IOSSCellGridReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['apply_displacements', 'caching', 'element_and_side_ids',
            'generate_file_id', 'merge_exodus_entity_blocks',
            'read_all_files_to_determine_structure', 'read_global_fields',
            'read_ids', 'read_qa_and_information_records', 'remove_unused_points',
            'scan_for_related_files'], [], ['abort_output',
            'database_type_override', 'displacement_magnitude',
            'field_suffix_separator', 'file_name', 'file_range', 'file_stride',
            'group_numeric_vector_field_components', 'object_name']),
            title='Edit IOSSCellGridReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit IOSSCellGridReader properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

