# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.prop import Prop


class LegendScaleActor(Prop):
    r"""
    LegendScaleActor - annotate the render window with scale and
    distance information
    
    Superclass: Prop
    
    This class is used to annotate the render window. Its basic goal is
    to provide an indication of the scale of the scene. Four axes
    surrounding the render window indicate (in a variety of ways) the
    scale of what the camera is viewing. An option also exists for
    displaying a scale legend.
    
    The axes can be programmed either to display distance scales or
    coordinate values. By default, the scales display a distance.
    However, if you know that the view is down a scene axis, the scales
    can be programmed to display coordinate values.
    
    @warning
    Please be aware that the axes and scale values are subject to
    perspective effects. The distances are computed in the focal plane of
    the camera. When there are large view angles (i.e., perspective
    projection), the computed distances may provide users the wrong sense
    of scale. These effects are not present when parallel projection is
    enabled.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkLegendScaleActor, obj, update, **traits)
    
    bottom_axis_visibility = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _bottom_axis_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBottomAxisVisibility,
                        self.bottom_axis_visibility_)

    grid_visibility = tvtk_base.false_bool_trait(desc=\
        r"""
        Set/Get visibility of the grid.
        """
    )

    def _grid_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetGridVisibility,
                        self.grid_visibility_)

    left_axis_visibility = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _left_axis_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLeftAxisVisibility,
                        self.left_axis_visibility_)

    legend_visibility = tvtk_base.true_bool_trait(desc=\
        r"""
        Indicate whether the legend scale should be displayed or not. The
        default is On.
        """
    )

    def _legend_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLegendVisibility,
                        self.legend_visibility_)

    right_axis_visibility = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/Get the flags that control which of the four axes to display
        (top, bottom, left and right). By default, all the axes are
        displayed.
        """
    )

    def _right_axis_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRightAxisVisibility,
                        self.right_axis_visibility_)

    top_axis_visibility = tvtk_base.true_bool_trait(desc=\
        r"""
        
        """
    )

    def _top_axis_visibility_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTopAxisVisibility,
                        self.top_axis_visibility_)

    label_mode = tvtk_base.RevPrefixMap({'distance': 0, 'coordinates': 1, 'xy_coordinates': 1}, default_value='distance', desc=\
        r"""
        Specify the mode for labeling the scale axes. By default, the
        axes are labeled with the distance between points (centered at a
        distance of 0.0). Alternatively if you know that the view is
        align with the scene axes, axes can be labeled with coordinates
        values.
        """
    )

    def _label_mode_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLabelMode,
                        self.label_mode_)

    def _get_axes_property(self):
        return wrap_vtk(self._vtk_obj.GetAxesProperty())
    def _set_axes_property(self, arg):
        old_val = self._get_axes_property()
        self._wrap_call(self._vtk_obj.SetAxesProperty,
                        deref_vtk(arg))
        self.trait_property_changed('axes_property', old_val, arg)
    axes_property = traits.Property(_get_axes_property, _set_axes_property, desc=\
        r"""
        Return the property used for the right axis which should be the
        same as the other ones if set using `set_axes_property`
        """
    )

    bottom_border_offset = traits.Trait(30, traits.Range(5, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the offset of the bottom axis from the border. This
        number is expressed in pixels, and represents the approximate
        distance of the axes from the sides of the renderer. The default
        is 30.
        """
    )

    def _bottom_border_offset_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBottomBorderOffset,
                        self.bottom_border_offset)

    corner_offset_factor = traits.Trait(2.0, traits.Range(1.0, 10.0, enter_set=True, auto_set=False), desc=\
        r"""
        Get/Set the corner offset. This is the offset factor used to
        offset the axes at the corners. Default value is 2.0.
        """
    )

    def _corner_offset_factor_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCornerOffsetFactor,
                        self.corner_offset_factor)

    left_border_offset = traits.Trait(50, traits.Range(5, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the offset of the left axis from the border. This number
        is expressed in pixels, and represents the approximate distance
        of the axes from the sides of the renderer. The default is 50.
        """
    )

    def _left_border_offset_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLeftBorderOffset,
                        self.left_border_offset)

    notation = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Get/set the numerical notation for axes labels: standard,
        scientific or mixed (0, 1, 2). Default is 0.
        """
    )

    def _notation_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNotation,
                        self.notation)

    number_of_horizontal_labels = traits.Int(5, enter_set=True, auto_set=False, desc=\
        r"""
        Get/set the number of ticks (and labels) for the horizontal axis,
        default is 5.
        """
    )

    def _number_of_horizontal_labels_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfHorizontalLabels,
                        self.number_of_horizontal_labels)

    number_of_vertical_labels = traits.Int(5, enter_set=True, auto_set=False, desc=\
        r"""
        Get/set the number of ticks (and labels) for the vertical axis,
        default is 5.
        """
    )

    def _number_of_vertical_labels_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfVerticalLabels,
                        self.number_of_vertical_labels)

    origin = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Get/Set the origin of the data. Used only in Coordinates mode.
        """
    )

    def _origin_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrigin,
                        self.origin)

    precision = traits.Int(2, enter_set=True, auto_set=False, desc=\
        r"""
        Get/set the numerical precision to use for axis labels, default
        is 2.
        """
    )

    def _precision_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPrecision,
                        self.precision)

    right_border_offset = traits.Trait(50, traits.Range(5, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the offset of the right axis from the border. This number
        is expressed in pixels, and represents the approximate distance
        of the axes from the sides of the renderer. The default is 50.
        """
    )

    def _right_border_offset_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRightBorderOffset,
                        self.right_border_offset)

    top_border_offset = traits.Trait(30, traits.Range(5, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the offset of the top axis from the border. This number
        is expressed in pixels, and represents the approximate distance
        of the axes from the sides of the renderer. The default is 30.
        """
    )

    def _top_border_offset_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTopBorderOffset,
                        self.top_border_offset)

    def _get_bottom_axis(self):
        return wrap_vtk(self._vtk_obj.GetBottomAxis())
    bottom_axis = traits.Property(_get_bottom_axis, desc=\
        r"""
        
        """
    )

    def _get_left_axis(self):
        return wrap_vtk(self._vtk_obj.GetLeftAxis())
    left_axis = traits.Property(_get_left_axis, desc=\
        r"""
        
        """
    )

    def _get_legend_label_property(self):
        return wrap_vtk(self._vtk_obj.GetLegendLabelProperty())
    legend_label_property = traits.Property(_get_legend_label_property, desc=\
        r"""
        
        """
    )

    def _get_legend_title_property(self):
        return wrap_vtk(self._vtk_obj.GetLegendTitleProperty())
    legend_title_property = traits.Property(_get_legend_title_property, desc=\
        r"""
        Set/Get the labels text properties for the legend title and
        labels.
        """
    )

    def _get_right_axis(self):
        return wrap_vtk(self._vtk_obj.GetRightAxis())
    right_axis = traits.Property(_get_right_axis, desc=\
        r"""
        These are methods to retrieve the AxisActors used to represent
        the four axes that form this representation. Users may retrieve
        and then modify these axes to control their appearance.
        """
    )

    def _get_top_axis(self):
        return wrap_vtk(self._vtk_obj.GetTopAxis())
    top_axis = traits.Property(_get_top_axis, desc=\
        r"""
        
        """
    )

    def all_annotations_off(self):
        """
        all_annotations_off(self) -> None
        C++: void all_annotations_off()"""
        ret = self._vtk_obj.AllAnnotationsOff()
        return ret
        

    def all_annotations_on(self):
        """
        all_annotations_on(self) -> None
        C++: void all_annotations_on()
        Convenience method that turns all the axes and the legend scale.
        """
        ret = self._vtk_obj.AllAnnotationsOn()
        return ret
        

    def all_axes_off(self):
        """
        all_axes_off(self) -> None
        C++: void all_axes_off()"""
        ret = self._vtk_obj.AllAxesOff()
        return ret
        

    def all_axes_on(self):
        """
        all_axes_on(self) -> None
        C++: void all_axes_on()
        Convenience method that turns all the axes either on or off.
        """
        ret = self._vtk_obj.AllAxesOn()
        return ret
        

    def build_representation(self, *args):
        """
        build_representation(self, viewport:Viewport) -> None
        C++: virtual void build_representation(Viewport *viewport)
        Standard methods supporting the rendering process.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.BuildRepresentation, *my_args)
        return ret

    def set_adjust_labels(self, *args):
        """
        set_adjust_labels(self, adjust:bool) -> None
        C++: void set_adjust_labels(bool adjust)
        Set the axes to adjust labels to a "nice" one. As this does not
        respect the number of labels, prefer snap_to_grid. It is ignored if
        snap_to_grid is true. Default is false.
        """
        ret = self._wrap_call(self._vtk_obj.SetAdjustLabels, *args)
        return ret

    def set_axes_text_property(self, *args):
        """
        set_axes_text_property(self, property:TextProperty) -> None
        C++: void set_axes_text_property(TextProperty *property)
        Set the axes text properties.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.SetAxesTextProperty, *my_args)
        return ret

    def set_snap_to_grid(self, *args):
        """
        set_snap_to_grid(self, snap:bool) -> None
        C++: void set_snap_to_grid(bool snap)
        If on, labels are positioned on rounded values. When on it
        ignores `adjust_labels`. Default is false.
        """
        ret = self._wrap_call(self._vtk_obj.SetSnapToGrid, *args)
        return ret

    def set_use_font_size_from_property(self, *args):
        """
        set_use_font_size_from_property(self, sizeFromProp:bool) -> None
        C++: void set_use_font_size_from_property(bool sizeFromProp)
        Set the axes to get font size from text property.
        """
        ret = self._wrap_call(self._vtk_obj.SetUseFontSizeFromProperty, *args)
        return ret

    _updateable_traits_ = \
    (('bottom_axis_visibility', 'GetBottomAxisVisibility'),
    ('grid_visibility', 'GetGridVisibility'), ('left_axis_visibility',
    'GetLeftAxisVisibility'), ('legend_visibility',
    'GetLegendVisibility'), ('right_axis_visibility',
    'GetRightAxisVisibility'), ('top_axis_visibility',
    'GetTopAxisVisibility'), ('dragable', 'GetDragable'), ('pickable',
    'GetPickable'), ('use_bounds', 'GetUseBounds'), ('visibility',
    'GetVisibility'), ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('label_mode', 'GetLabelMode'),
    ('bottom_border_offset', 'GetBottomBorderOffset'),
    ('corner_offset_factor', 'GetCornerOffsetFactor'),
    ('left_border_offset', 'GetLeftBorderOffset'), ('notation',
    'GetNotation'), ('number_of_horizontal_labels',
    'GetNumberOfHorizontalLabels'), ('number_of_vertical_labels',
    'GetNumberOfVerticalLabels'), ('origin', 'GetOrigin'), ('precision',
    'GetPrecision'), ('right_border_offset', 'GetRightBorderOffset'),
    ('top_border_offset', 'GetTopBorderOffset'), ('estimated_render_time',
    'GetEstimatedRenderTime'), ('render_time_multiplier',
    'GetRenderTimeMultiplier'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['bottom_axis_visibility', 'debug', 'dragable',
    'global_warning_display', 'grid_visibility', 'left_axis_visibility',
    'legend_visibility', 'pickable', 'right_axis_visibility',
    'top_axis_visibility', 'use_bounds', 'visibility', 'label_mode',
    'bottom_border_offset', 'corner_offset_factor',
    'estimated_render_time', 'left_border_offset', 'notation',
    'number_of_horizontal_labels', 'number_of_vertical_labels',
    'object_name', 'origin', 'precision', 'render_time_multiplier',
    'right_border_offset', 'top_border_offset'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(LegendScaleActor, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit LegendScaleActor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['bottom_axis_visibility', 'grid_visibility',
            'left_axis_visibility', 'legend_visibility', 'right_axis_visibility',
            'top_axis_visibility', 'use_bounds', 'visibility'], ['label_mode'],
            ['bottom_border_offset', 'corner_offset_factor',
            'estimated_render_time', 'left_border_offset', 'notation',
            'number_of_horizontal_labels', 'number_of_vertical_labels',
            'object_name', 'origin', 'precision', 'render_time_multiplier',
            'right_border_offset', 'top_border_offset']),
            title='Edit LegendScaleActor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit LegendScaleActor properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

