# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell import Cell


class NonLinearCell(Cell):
    r"""
    NonLinearCell - abstract superclass for non-linear cells
    
    Superclass: Cell
    
    NonLinearCell is an abstract superclass for non-linear cell types.
    Cells that are a direct subclass of Cell or Cell3D are linear;
    cells that are a subclass of NonLinearCell have non-linear
    interpolation functions. Non-linear cells require special treatment
    when tessellating or converting to graphics primitives. Note that the
    linearity of the cell is a function of whether the cell needs
    tessellation, which does not strictly correlate with interpolation
    order (e.g., Hexahedron has non-linear interpolation functions (a
    product of three linear functions in r-s-t) even thought
    Hexahedron is considered linear.)
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkNonLinearCell, obj, update, **traits)
    
    def stable_clip(self, *args):
        """
        stable_clip(self, value:float, cellScalars:DataArray,
            locator:IncrementalPointLocator, connectivity:CellArray,
             inPd:PointData, outPd:PointData, inCd:CellData,
            cellId:int, outCd:CellData, insideOut:int) -> bool
        C++: virtual bool stable_clip(double value,
            DataArray *cellScalars,
            IncrementalPointLocator *locator,
            CellArray *connectivity, PointData *inPd,
            PointData *outPd, CellData *inCd, IdType cellId,
            CellData *outCd, int insideOut)
        Clip the cell based on the input cellScalars and the specified
        value. The output of the clip operation will be one or more cells
        of the same topological dimension as the original cell. For more
        information see Cell::Clip.
        
        This method differs from the Cell::Clip function in such a way
        that it tells more information about how the clipped cell was
        handled. For 2D cells Cell::Clip is expected to return either
        triangles, quads or polygon, and for 3D cells either tetras or
        wedges. However, it is interesting (especially for non linear
        cells) to be able to return the same cell type when the cell is
        totally inside or outside the clipping function. This Clip
        function resolves exactly this issue by returning a bool : if
        stable_clip returns true then the newly inserted cell is the same
        type as the current cell, otherwise it will be one of the
        "expected" types as returned by Cell::Clip.
        
        Note: This function could also benefit being moved to Cell but
        requires much more work to be supported by all cell types.
        
        @see Cell::Clip
        """
        my_args = deref_array(args, [('float', 'vtkDataArray', 'vtkIncrementalPointLocator', 'vtkCellArray', 'vtkPointData', 'vtkPointData', 'vtkCellData', 'int', 'vtkCellData', 'int')])
        ret = self._wrap_call(self._vtk_obj.StableClip, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(NonLinearCell, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit NonLinearCell properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit NonLinearCell properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit NonLinearCell properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

