# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class OpenGLBufferObject(Object):
    r"""
    OpenGLBufferObject - open_gl buffer object
    
    Superclass: Object
    
    open_gl buffer object to store index, geometry and/or attribute data
    on the GPU.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOpenGLBufferObject, obj, update, **traits)
    
    def _get_error(self):
        return self._vtk_obj.GetError()
    error = traits.Property(_get_error, desc=\
        r"""
        Return a string describing errors.
        """
    )

    def _get_handle(self):
        return self._vtk_obj.GetHandle()
    handle = traits.Property(_get_handle, desc=\
        r"""
        Get the handle of the buffer object.
        """
    )

    def _get_size(self):
        return self._vtk_obj.GetSize()
    size = traits.Property(_get_size, desc=\
        r"""
        Get size of the buffer in bytes.
        """
    )

    def allocate(self, *args):
        """
        allocate(self, size:int, type:ObjectType, usage:ObjectUsage)
            -> bool
        C++: bool allocate(size_t size, ObjectType type,
            ObjectUsage usage)
        Allocates a buffer of `type` with `size` bytes.
        """
        ret = self._wrap_call(self._vtk_obj.Allocate, *args)
        return ret

    def bind(self):
        """
        bind(self) -> bool
        C++: bool bind()
        Bind the buffer object ready for rendering.
        
        ote Only one ARRAY_BUFFER and one ELEMENT_ARRAY_BUFFER may be
        bound at any time.
        """
        ret = self._vtk_obj.Bind()
        return ret
        

    def bind_shader_storage(self, *args):
        """
        bind_shader_storage(self, index:int) -> bool
        C++: bool bind_shader_storage(int index)
        Bind the buffer to a shader storage point.
        """
        ret = self._wrap_call(self._vtk_obj.BindShaderStorage, *args)
        return ret

    def flag_buffer_as_dirty(self):
        """
        flag_buffer_as_dirty(self) -> None
        C++: void flag_buffer_as_dirty()
        Indicate that the buffer object needs to be re-uploaded.
        """
        ret = self._vtk_obj.FlagBufferAsDirty()
        return ret
        

    def generate_buffer(self, *args):
        """
        generate_buffer(self, type:ObjectType) -> bool
        C++: bool generate_buffer(ObjectType type)
        Generate the opengl buffer for this Handle
        """
        ret = self._wrap_call(self._vtk_obj.GenerateBuffer, *args)
        return ret

    def is_ready(self):
        """
        is_ready(self) -> bool
        C++: bool is_ready()
        Determine if the buffer object is ready to be used.
        """
        ret = self._vtk_obj.IsReady()
        return ret
        

    def release(self):
        """
        release(self) -> bool
        C++: bool release()
        Release the buffer. This should be done after rendering is
        complete.
        """
        ret = self._vtk_obj.Release()
        return ret
        

    def release_graphics_resources(self):
        """
        release_graphics_resources(self) -> None
        C++: void release_graphics_resources()
        Release any graphics resources that are being consumed by this
        class.
        """
        ret = self._vtk_obj.ReleaseGraphicsResources()
        return ret
        

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OpenGLBufferObject, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OpenGLBufferObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name']),
            title='Edit OpenGLBufferObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OpenGLBufferObject properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

