# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class OrientPolyData(PolyDataAlgorithm):
    r"""
    OrientPolyData - Auto detect correct normal orientation and/or
    enforce consistent polygon ordering.
    
    Superclass: PolyDataAlgorithm
    
    OrientPolyData is a filter that orients the normals of a polygonal
    mesh, and/or enforces consistent polygon ordering. It is also
    possible to globally flip the normal orientation.
    
    @sa
    PolyDataNormals SplitPolyData
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOrientPolyData, obj, update, **traits)
    
    auto_orient_normals = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off the automatic determination of correct normal
        orientation. NOTE: This assumes a completely closed surface (i.e.
        no boundary edges) and no non-manifold edges. If these
        constraints do not hold, all bets are off. This option adds some
        computational complexity, and is useful if you don't want to have
        to inspect the rendered image to determine whether to turn on the
        flip_normals flag. However, this flag can work with the
        flip_normals flag, and if both are set, all the normals in the
        output will point "inward".
        
        The default is off.
        """
    )

    def _auto_orient_normals_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAutoOrientNormals,
                        self.auto_orient_normals_)

    consistency = tvtk_base.true_bool_trait(desc=\
        r"""
        Turn on/off the enforcement of consistent polygon ordering.
        
        The default is on.
        """
    )

    def _consistency_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetConsistency,
                        self.consistency_)

    flip_normals = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off the global flipping of normal orientation. Flipping
        reverves the meaning of front and back for Frontface and Backface
        culling in Property.  Flipping modifies both the normal
        direction and the order of a cell's points.
        
        The default is off.
        """
    )

    def _flip_normals_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetFlipNormals,
                        self.flip_normals_)

    non_manifold_traversal = tvtk_base.false_bool_trait(desc=\
        r"""
        Turn on/off traversal across non-manifold edges. This will
        prevent problems where the consistency of polygonal ordering is
        corrupted due to topological loops.
        
        The default is off.
        """
    )

    def _non_manifold_traversal_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNonManifoldTraversal,
                        self.non_manifold_traversal_)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('auto_orient_normals', 'GetAutoOrientNormals'), ('consistency',
    'GetConsistency'), ('flip_normals', 'GetFlipNormals'),
    ('non_manifold_traversal', 'GetNonManifoldTraversal'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'auto_orient_normals', 'consistency', 'debug',
    'flip_normals', 'global_warning_display', 'non_manifold_traversal',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OrientPolyData, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OrientPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['auto_orient_normals', 'consistency', 'flip_normals',
            'non_manifold_traversal'], [], ['abort_output', 'object_name']),
            title='Edit OrientPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OrientPolyData properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

