# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_mapper import PolyDataMapper


class PointGaussianMapper(PolyDataMapper):
    r"""
    PointGaussianMapper - draw point_gaussians using imposters
    
    Superclass: PolyDataMapper
    
    A mapper that uses imposters to draw gaussian splats or other shapes
    if custom shader code is set. Supports transparency and picking as
    well. It draws all the points and does not require cell arrays. If
    cell arrays are provided it will only draw the points used by the
    Verts cell array. The shape of the imposter is a triangle.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkPointGaussianMapper, obj, update, **traits)
    
    anisotropic = tvtk_base.false_bool_trait(desc=\
        r"""
        If enabled, the gaussian can be stretched and oriented on some
        direction. A 3x3 covariance matrix is built using the scale array
        and the rotation array. Since a 3D vector is expected, the value
        in scale_array_component is ignored. Default value is false.
        """
    )

    def _anisotropic_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAnisotropic,
                        self.anisotropic_)

    emissive = tvtk_base.true_bool_trait(desc=\
        r"""
        Treat the points/splats as emissive light sources. The default is
        true.
        """
    )

    def _emissive_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetEmissive,
                        self.emissive_)

    bound_scale = traits.Float(3.0, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _bound_scale_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBoundScale,
                        self.bound_scale)

    lowpass_matrix = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.0, 0.0, 0.0), cols=3, desc=\
        r"""
        Once the 2D covariance matrix is computed, it's possible to add a
        custom low pass matrix to apply a convolution to the splat. It's
        useful to make sure the splat is at least one pixel wide for
        example. The 2x2 matrix to apply is stored as a 3D vector because
        it's symmetric. The first element is the first diagonal value,
        the second element is the off diagonal value, and the third
        element is the second diagonal value. Default is zero, meaning no
        convolution is applied.
        """
    )

    def _lowpass_matrix_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetLowpassMatrix,
                        self.lowpass_matrix)

    opacity_array = traits.Trait(None, None, traits.String(enter_set=True, auto_set=False), desc=\
        r"""
        Method to set the optional opacity array.  If specified this
        array will be used to generate the opacity values.
        """
    )

    def _opacity_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOpacityArray,
                        self.opacity_array)

    opacity_array_component = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Convenience method to set the component of the array to opacify
        with.
        """
    )

    def _opacity_array_component_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOpacityArrayComponent,
                        self.opacity_array_component)

    opacity_table_size = traits.Int(1024, enter_set=True, auto_set=False, desc=\
        r"""
        The size of the table used in computing opacities, used when
        converting a PiecewiseFunction to a table
        """
    )

    def _opacity_table_size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOpacityTableSize,
                        self.opacity_table_size)

    rotation_array = traits.Trait(None, None, traits.String(enter_set=True, auto_set=False), desc=\
        r"""
        Set the array containing the rotation of each point. The array
        must contain quaternions (4 components). Must be specified is
        Anisotropic is true. Default value is nullptr.
        """
    )

    def _rotation_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetRotationArray,
                        self.rotation_array)

    def _get_scalar_opacity_function(self):
        return wrap_vtk(self._vtk_obj.GetScalarOpacityFunction())
    def _set_scalar_opacity_function(self, arg):
        old_val = self._get_scalar_opacity_function()
        self._wrap_call(self._vtk_obj.SetScalarOpacityFunction,
                        deref_vtk(arg))
        self.trait_property_changed('scalar_opacity_function', old_val, arg)
    scalar_opacity_function = traits.Property(_get_scalar_opacity_function, _set_scalar_opacity_function, desc=\
        r"""
        
        """
    )

    scale_array = traits.Trait(None, None, traits.String(enter_set=True, auto_set=False), desc=\
        r"""
        Convenience method to set the array to scale with.
        """
    )

    def _scale_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleArray,
                        self.scale_array)

    scale_array_component = traits.Int(0, enter_set=True, auto_set=False, desc=\
        r"""
        Convenience method to set the component of the array to scale
        with.
        """
    )

    def _scale_array_component_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleArrayComponent,
                        self.scale_array_component)

    scale_factor = traits.Float(1.0, enter_set=True, auto_set=False, desc=\
        r"""
        Set the default scale factor of the point gaussians.  This
        defaults to 1.0. All radius computations will be scaled by the
        factor including the scale_array. If a PiecewideFunction is
        used the scaling happens prior to the function lookup. A scale
        factor of 0.0 indicates that the splats should be rendered as
        simple points.
        """
    )

    def _scale_factor_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleFactor,
                        self.scale_factor)

    def _get_scale_function(self):
        return wrap_vtk(self._vtk_obj.GetScaleFunction())
    def _set_scale_function(self, arg):
        old_val = self._get_scale_function()
        self._wrap_call(self._vtk_obj.SetScaleFunction,
                        deref_vtk(arg))
        self.trait_property_changed('scale_function', old_val, arg)
    scale_function = traits.Property(_get_scale_function, _set_scale_function, desc=\
        r"""
        
        """
    )

    scale_table_size = traits.Int(1024, enter_set=True, auto_set=False, desc=\
        r"""
        The size of the table used in computing scale, used when
        converting a PiecewiseFunction to a table
        """
    )

    def _scale_table_size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetScaleTableSize,
                        self.scale_table_size)

    splat_shader_code = traits.Trait(None, None, traits.String(enter_set=True, auto_set=False), desc=\
        r"""
        Method to override the fragment shader code for the splat.  You
        can set this to draw other shapes. For the Open_gl2 backend some
        of the variables you can use and/or modify include, opacity - 0.0
        to 1.0 diffuseColor - vec3 ambientColor - vec3 offsetVCVSOutput -
        vec2 offset in view coordinates from the splat center
        """
    )

    def _splat_shader_code_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSplatShaderCode,
                        self.splat_shader_code)

    triangle_scale = traits.Float(3.0, enter_set=True, auto_set=False, desc=\
        r"""
        When drawing splats as opposed to point mode (splats are bigger
        than a pixel) this controls how large the splat bound primitive
        will be. By default it is large enough to contain a cicle of
        radius 3.0*scale which works well for gaussian splats as after
        3.0 standard deviations the opacity is near zero. For custom
        shader codes a different value can be used. Generally you should
        use the lowest value you can as it will result in fewer
        fragments. For example if your custom shader only draws a disc of
        radius 1.0*scale, then set this to 1.0 to avoid sending many
        fragments to the shader that will just get discarded.
        """
    )

    def _triangle_scale_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTriangleScale,
                        self.triangle_scale)

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input as a DataSet.  This method is overridden in the
        specialized mapper classes to return more specific data types.
        """
    )

    _updateable_traits_ = \
    (('anisotropic', 'GetAnisotropic'), ('emissive', 'GetEmissive'),
    ('pause_shift_scale', 'GetPauseShiftScale'), ('seamless_u',
    'GetSeamlessU'), ('seamless_v', 'GetSeamlessV'),
    ('interpolate_scalars_before_mapping',
    'GetInterpolateScalarsBeforeMapping'), ('scalar_visibility',
    'GetScalarVisibility'), ('static', 'GetStatic'),
    ('use_lookup_table_scalar_range', 'GetUseLookupTableScalarRange'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('color_mode',
    'GetColorMode'), ('resolve_coincident_topology',
    'GetResolveCoincidentTopology'), ('scalar_mode', 'GetScalarMode'),
    ('bound_scale', 'GetBoundScale'), ('lowpass_matrix',
    'GetLowpassMatrix'), ('opacity_array', 'GetOpacityArray'),
    ('opacity_array_component', 'GetOpacityArrayComponent'),
    ('opacity_table_size', 'GetOpacityTableSize'), ('rotation_array',
    'GetRotationArray'), ('scale_array', 'GetScaleArray'),
    ('scale_array_component', 'GetScaleArrayComponent'), ('scale_factor',
    'GetScaleFactor'), ('scale_table_size', 'GetScaleTableSize'),
    ('splat_shader_code', 'GetSplatShaderCode'), ('triangle_scale',
    'GetTriangleScale'), ('ghost_level', 'GetGhostLevel'),
    ('number_of_pieces', 'GetNumberOfPieces'), ('number_of_sub_pieces',
    'GetNumberOfSubPieces'), ('piece', 'GetPiece'),
    ('vbo_shift_scale_method', 'GetVBOShiftScaleMethod'),
    ('array_access_mode', 'GetArrayAccessMode'), ('array_component',
    'GetArrayComponent'), ('array_id', 'GetArrayId'), ('array_name',
    'GetArrayName'), ('field_data_tuple_id', 'GetFieldDataTupleId'),
    ('render_time', 'GetRenderTime'),
    ('resolve_coincident_topology_polygon_offset_faces',
    'GetResolveCoincidentTopologyPolygonOffsetFaces'),
    ('resolve_coincident_topology_z_shift',
    'GetResolveCoincidentTopologyZShift'), ('scalar_range',
    'GetScalarRange'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'anisotropic', 'debug', 'emissive',
    'global_warning_display', 'interpolate_scalars_before_mapping',
    'pause_shift_scale', 'release_data_flag', 'scalar_visibility',
    'seamless_u', 'seamless_v', 'static', 'use_lookup_table_scalar_range',
    'color_mode', 'resolve_coincident_topology', 'scalar_mode',
    'abort_output', 'array_access_mode', 'array_component', 'array_id',
    'array_name', 'bound_scale', 'field_data_tuple_id', 'ghost_level',
    'lowpass_matrix', 'number_of_pieces', 'number_of_sub_pieces',
    'object_name', 'opacity_array', 'opacity_array_component',
    'opacity_table_size', 'piece', 'progress_text', 'render_time',
    'resolve_coincident_topology_polygon_offset_faces',
    'resolve_coincident_topology_z_shift', 'rotation_array',
    'scalar_range', 'scale_array', 'scale_array_component',
    'scale_factor', 'scale_table_size', 'splat_shader_code',
    'triangle_scale', 'vbo_shift_scale_method'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(PointGaussianMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit PointGaussianMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['anisotropic', 'emissive',
            'interpolate_scalars_before_mapping', 'pause_shift_scale',
            'scalar_visibility', 'seamless_u', 'seamless_v', 'static',
            'use_lookup_table_scalar_range'], ['color_mode',
            'resolve_coincident_topology', 'scalar_mode'], ['abort_output',
            'array_access_mode', 'array_component', 'array_id', 'array_name',
            'bound_scale', 'field_data_tuple_id', 'ghost_level', 'lowpass_matrix',
            'number_of_pieces', 'number_of_sub_pieces', 'object_name',
            'opacity_array', 'opacity_array_component', 'opacity_table_size',
            'piece', 'render_time',
            'resolve_coincident_topology_polygon_offset_faces',
            'resolve_coincident_topology_z_shift', 'rotation_array',
            'scalar_range', 'scale_array', 'scale_array_component',
            'scale_factor', 'scale_table_size', 'splat_shader_code',
            'triangle_scale', 'vbo_shift_scale_method']),
            title='Edit PointGaussianMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit PointGaussianMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

