# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.poly_data_algorithm import PolyDataAlgorithm


class PointSetStreamer(PolyDataAlgorithm):
    r"""
    PointSetStreamer - stream points as buckets
    
    Superclass: PolyDataAlgorithm
    
    PointSetStreamer is a filter that sorts points into buckets and it
    returns the points included in the chosen bucket. The bucket is
    chosen by setting the bucket_id. The purpose of this class is to allow
    streaming of points. The bucket size is determined by the
    number_of_points_per_bucket.
    
    The typical usage is to call this filter the first time to perform
    the sorting and get the points in the first bucket and then to call
    it again to get the points in the remaining buckets. The sorting is
    performed only the first time, assuming that the dataset or
    number_of_points_per_bucket don't change. The number of buckets can be
    obtained by calling get_number_of_buckets.
    
    @sa PointSetToOctreeImageFilter StaticPointLocator
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkPointSetStreamer, obj, update, **traits)
    
    create_vertices_cell_array = tvtk_base.true_bool_trait(desc=\
        r"""
        Set/Get if a cell array of vertices will be created.
        
        The default is on.
        """
    )

    def _create_vertices_cell_array_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetCreateVerticesCellArray,
                        self.create_vertices_cell_array_)

    bucket_id = traits.Trait(0, traits.Range(0, 9223372036854775807, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the bucket id to stream. This data member is used to
        determine the number of buckets.
        
        The default is 0.
        """
    )

    def _bucket_id_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetBucketId,
                        self.bucket_id)

    number_of_points_per_bucket = traits.Trait(1, traits.Range(1, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the average number of points in each bucket. This data
        member is used to determine the number of buckets.
        
        The default is 1.
        """
    )

    def _number_of_points_per_bucket_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfPointsPerBucket,
                        self.number_of_points_per_bucket)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)"""
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def _get_number_of_buckets(self):
        return self._vtk_obj.GetNumberOfBuckets()
    number_of_buckets = traits.Property(_get_number_of_buckets, desc=\
        r"""
        Get the number of buckets.
        
        Note: This method must be called after the first pass.
        """
    )

    _updateable_traits_ = \
    (('create_vertices_cell_array', 'GetCreateVerticesCellArray'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('bucket_id',
    'GetBucketId'), ('number_of_points_per_bucket',
    'GetNumberOfPointsPerBucket'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'create_vertices_cell_array', 'debug',
    'global_warning_display', 'release_data_flag', 'abort_output',
    'bucket_id', 'number_of_points_per_bucket', 'object_name',
    'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(PointSetStreamer, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit PointSetStreamer properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['create_vertices_cell_array'], [], ['abort_output',
            'bucket_id', 'number_of_points_per_bucket', 'object_name']),
            title='Edit PointSetStreamer properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit PointSetStreamer properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

