# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.cell import Cell


class Polygon(Cell):
    r"""
    Polygon - a cell that represents an n-sided polygon
    
    Superclass: Cell
    
    Polygon is a concrete implementation of Cell to represent a 2D
    n-sided polygon. The polygons cannot have any internal holes, and
    cannot self-intersect. Define the polygon with n-points ordered in
    the counter- clockwise direction; do not repeat the last point.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkPolygon, obj, update, **traits)
    
    tolerance = traits.Trait(1e-06, traits.Range(0.0, 1.0, enter_set=True, auto_set=False), desc=\
        r"""
        Specify an internal tolerance for operations requiring polygon
        triangulation.  (For example, clipping and contouring operations
        proceed by first triangulating the polygon, and then
        clipping/contouring the resulting triangles.)  This is a
        normalized tolerance value multiplied by the diagonal length of
        the polygon bounding box. Is it used to determine whether
        potential triangulation edges intersect one another.
        """
    )

    def _tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTolerance,
                        self.tolerance)

    use_mvc_interpolation = traits.Bool(False, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _use_mvc_interpolation_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseMVCInterpolation,
                        self.use_mvc_interpolation)

    def bounded_triangulate(self, *args):
        """
        bounded_triangulate(self, outTris:IdList, tol:float) -> int
        C++: int bounded_triangulate(IdList *outTris, double tol)
        Triangulate polygon and enforce that the ratio of the smallest
        triangle area to the polygon area is greater than a user-defined
        tolerance. The user must provide the IdList outTris. On
        output, the outTris list contains the ids of the points defining
        the triangulation. The ids are ordered into groups of three: each
        three-group defines one triangle.
        """
        my_args = deref_array(args, [('vtkIdList', 'float')])
        ret = self._wrap_call(self._vtk_obj.BoundedTriangulate, *my_args)
        return ret

    def compute_area(self, *args):
        """
        compute_area(self) -> float
        C++: double compute_area()
        compute_area(p:Points, numPts:int, pts:(int, ...),
            normal:[float, float, float]) -> float
        C++: static double compute_area(Points *p, IdType numPts,
            const IdType *pts, double normal[3])
        Compute the area of a polygon. This is a convenience function
        which simply calls static double compute_area(Points *p,
        IdType numPts, IdType *pts, double normal[3]); with the
        appropriate parameters from the instantiated Polygon.
        """
        my_args = deref_array(args, [None, ('vtkPoints', 'int', ('int', Ellipsis), ['float', 'float', 'float'])])
        ret = self._wrap_call(self._vtk_obj.ComputeArea, *my_args)
        return ret

    def compute_centroid(self, *args):
        """
        compute_centroid(p:Points, numPts:int, pts:(int, ...),
            centroid:[float, float, float]) -> bool
        C++: static bool compute_centroid(Points *p, int numPts,
            const IdType *pts, double centroid[3])
        compute_centroid(ids:IdTypeArray, pts:Points,
            centroid:[float, float, float]) -> bool
        C++: static bool compute_centroid(IdTypeArray *ids,
            Points *pts, double centroid[3])
        Compute the centroid of a set of points. Returns false if the
        computation is invalid (this occurs when numPts=0 or when ids is
        empty).
        """
        my_args = deref_array(args, [('vtkPoints', 'int', ('int', Ellipsis), ['float', 'float', 'float']), ('vtkIdTypeArray', 'vtkPoints', ['float', 'float', 'float'])])
        ret = self._wrap_call(self._vtk_obj.ComputeCentroid, *my_args)
        return ret

    def compute_normal(self, *args):
        """
        compute_normal(p:Points, numPts:int, pts:(int, ...), n:[float,
            float, float]) -> None
        C++: static void compute_normal(Points *p, int numPts,
            const IdType *pts, double n[3])
        compute_normal(p:Points, n:[float, float, float]) -> None
        C++: static void compute_normal(Points *p, double n[3])
        compute_normal(ids:IdTypeArray, pts:Points, n:[float, float,
            float]) -> None
        C++: static void compute_normal(IdTypeArray *ids,
            Points *pts, double n[3])
        compute_normal(numPts:int, pts:[float, ...], n:[float, float,
            float]) -> None
        C++: static void compute_normal(int numPts, double *pts,
            double n[3])
        Computes the unit normal to the polygon. If pts=nullptr, point
        indexing is assumed to be {0, 1, ..., numPts-1}.
        """
        my_args = deref_array(args, [('vtkPoints', 'int', ('int', Ellipsis), ['float', 'float', 'float']), ('vtkPoints', ['float', 'float', 'float']), ('vtkIdTypeArray', 'vtkPoints', ['float', 'float', 'float']), ('int', 'tuple', ['float', 'float', 'float'])])
        ret = self._wrap_call(self._vtk_obj.ComputeNormal, *my_args)
        return ret

    def distance_to_polygon(self, *args):
        """
        distance_to_polygon(x:[float, float, float], numPts:int, pts:[float,
             ...], bounds:[float, float, float, float, float, float],
            closest:[float, float, float]) -> float
        C++: static double distance_to_polygon(double x[3], int numPts,
            double *pts, double bounds[6], double closest[3])
        Compute the distance of a point to a polygon. The closest point
        on the polygon is also returned. The bounds should be provided to
        accelerate the computation.
        """
        ret = self._wrap_call(self._vtk_obj.DistanceToPolygon, *args)
        return ret

    def ear_cut_triangulation(self, *args):
        """
        ear_cut_triangulation(self, measure:int=...) -> int
        C++: int ear_cut_triangulation(int measure=PERIMETER2_TO_AREA_RATIO)
        ear_cut_triangulation(self, outTris:IdList, measure:int=...)
            -> int
        C++: int ear_cut_triangulation(IdList *outTris,
            int measure=PERIMETER2_TO_AREA_RATIO)
        A fast triangulation method. Uses recursive divide and conquer
        based on plane splitting to reduce loop into triangles. The cell
        (e.g., triangle) is presumed properly initialized (i.e., Points
        and point_ids). Ears can be removed using different measures (the
        measures indicate convexity plus characterize the local geometry
        around each vertex).
        """
        my_args = deref_array(args, [['int'], ('vtkIdList', 'int')])
        ret = self._wrap_call(self._vtk_obj.EarCutTriangulation, *my_args)
        return ret

    def intersect_convex2d_cells(self, *args):
        """
        intersect_convex2d_cells(cell1:Cell, cell2:Cell, tol:float,
            p0:[float, float, float], p1:[float, float, float]) -> int
        C++: static int intersect_convex2d_cells(Cell *cell1,
            Cell *cell2, double tol, double p0[3], double p1[3])
        Intersect two convex 2D polygons to produce a line segment as
        output. The return status of the methods indicated no
        intersection (returns 0); a single point of intersection (returns
        1); or a line segment (i.e., two points of intersection, returns
        2). The points of intersection are returned in the arrays p0 and
        p1.  If less than two points of intersection are generated then
        p1 and/or p0 may be indeterminiate. Finally, if the two convex
        polygons are parallel, then "0" is returned (i.e., no
        intersection) even if the triangles lie on one another.
        """
        my_args = [deref_vtk(x) for x in args]
        ret = self._wrap_call(self._vtk_obj.IntersectConvex2DCells, *my_args)
        return ret

    def intersect_polygon_with_polygon(self, *args):
        """
        intersect_polygon_with_polygon(npts:int, pts:[float, ...],
            bounds:[float, float, float, float, float, float], npts2:int,
            pts2:[float, ...], bounds2:[float, float, float, float, float,
             float], tol:float, x:[float, float, float]) -> int
        C++: static int intersect_polygon_with_polygon(int npts, double *pts,
             double bounds[6], int npts2, double *pts2, double bounds2[6],
             double tol, double x[3])
        Method intersects two polygons. You must supply the number of
        points and point coordinates (npts, *pts) and the bounding box
        (bounds) of the two polygons. Also supply a tolerance squared for
        controlling error. The method returns 1 if there is an
        intersection, and 0 if not. A single point of intersection x[3]
        is also returned if there is an intersection.
        """
        ret = self._wrap_call(self._vtk_obj.IntersectPolygonWithPolygon, *args)
        return ret

    def is_convex(self, *args):
        """
        is_convex(self) -> bool
        C++: bool is_convex()
        is_convex(p:Points, numPts:int, pts:(int, ...)) -> bool
        C++: static bool is_convex(Points *p, int numPts,
            const IdType *pts)
        is_convex(ids:IdTypeArray, p:Points) -> bool
        C++: static bool is_convex(IdTypeArray *ids, Points *p)
        is_convex(p:Points) -> bool
        C++: static bool is_convex(Points *p)
        Determine whether or not a polygon is convex. This is a
        convenience function that simply calls static bool is_convex(int
        numPts, IdType *pts, Points *p) with the appropriate
        parameters from the instantiated Polygon.
        """
        my_args = deref_array(args, [None, ('vtkPoints', 'int', ('int', Ellipsis)), ('vtkIdTypeArray', 'vtkPoints'), ['vtkPoints']])
        ret = self._wrap_call(self._vtk_obj.IsConvex, *my_args)
        return ret

    def non_degenerate_triangulate(self, *args):
        """
        non_degenerate_triangulate(self, outTris:IdList) -> int
        C++: int non_degenerate_triangulate(IdList *outTris)
        Same as Triangulate(vtkid_list *outTris) but with a first pass to
        split the polygon into non-degenerate polygons.
        """
        my_args = deref_array(args, [['vtkIdList']])
        ret = self._wrap_call(self._vtk_obj.NonDegenerateTriangulate, *my_args)
        return ret

    def parameterize_polygon(self, *args):
        """
        parameterize_polygon(self, p0:[float, float, float], p10:[float,
            float, float], l10:float, p20:[float, float, float],
            l20:float, n:[float, float, float]) -> int
        C++: int parameterize_polygon(double p0[3], double p10[3],
            double &l10, double p20[3], double &l20, double n[3])
        Create a local s-t coordinate system for a polygon. The point p0
        is the origin of the local system, p10 is s-axis vector, and p20
        is the t-axis vector. (These are expressed in the modeling
        coordinate system and are vectors of dimension [3].) The values
        l20 and l20 are the lengths of the vectors p10 and p20, and n is
        the polygon normal.
        """
        ret = self._wrap_call(self._vtk_obj.ParameterizePolygon, *args)
        return ret

    def point_in_polygon(self, *args):
        """
        point_in_polygon(x:[float, float, float], numPts:int, pts:[float,
            ...], bounds:[float, float, float, float, float, float],
            n:[float, float, float]) -> int
        C++: static int point_in_polygon(double x[3], int numPts,
            double *pts, double bounds[6], double n[3])
        Determine whether a point is inside the specified polygon. The
        function computes the winding number to assess inclusion. It
        works for arbitrary polygon shapes (e.g., non-convex) oriented
        arbitrarily in 3D space. Returns 0 if the point is not in the
        polygon; 1 if it is.  Can also return -1 to indicate a degenerate
        polygon. Parameters passed into the method include the point in
        question x[3]; the polygon defined by (npts,pts); the bounds of
        the polygon bounds[6]; and the normal n[3] to the polygon. (The
        implementation was inspired by Dan Sunday's book Practical
        Geometry Algorithms.) This method is thread safe.
        """
        ret = self._wrap_call(self._vtk_obj.PointInPolygon, *args)
        return ret

    def unbiased_ear_cut_triangulation(self, *args):
        """
        unbiased_ear_cut_triangulation(self, seed:int, measure:int=...)
            -> int
        C++: int unbiased_ear_cut_triangulation(int seed,
            int measure=PERIMETER2_TO_AREA_RATIO)
        unbiased_ear_cut_triangulation(self, seed:int, outTris:IdList,
            measure:int=...) -> int
        C++: int unbiased_ear_cut_triangulation(int seed, IdList *outTris,
             int measure=PERIMETER2_TO_AREA_RATIO)
        A fast triangulation method. Uses recursive divide and conquer
        based on plane splitting to reduce loop into triangles. The cell
        (e.g., triangle) is presumed properly initialized (i.e., Points
        and point_ids). Unlike ear_cut_triangulation(), vertices are visited
        sequentially without preference to angle.
        """
        my_args = deref_array(args, [('int', 'int'), ('int', 'vtkIdList', 'int')])
        ret = self._wrap_call(self._vtk_obj.UnbiasedEarCutTriangulation, *my_args)
        return ret

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('tolerance', 'GetTolerance'),
    ('use_mvc_interpolation', 'GetUseMVCInterpolation'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name', 'tolerance',
    'use_mvc_interpolation'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Polygon, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Polygon properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name', 'tolerance', 'use_mvc_interpolation']),
            title='Edit Polygon properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Polygon properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

