# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.actor2d import Actor2D


class RadialGridActor2D(Actor2D):
    r"""
    RadialGridActor2D - RadialGridActor2D displays in overlay a
    list of AxisActor2D sharing a same origin and rotating around it.
    
    Superclass: Actor2D
    
    Rotation is defined by a start and an end angle and the origin. This
    can be useful in a polar axes actor.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkRadialGridActor2D, obj, update, **traits)
    
    axes_viewport_length = traits.Trait(100.0, traits.Range(2.0, 1e+299, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the length of each axis, in viewport coordinates. Default
        is 100.
        """
    )

    def _axes_viewport_length_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetAxesViewportLength,
                        self.axes_viewport_length)

    end_angle = traits.Float(90.0, enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the end angle (in degrees) of the radial grid. This is
        the orientation of the last axis. Default is 90.
        
        @see set_start_angle, set_end_angle, set_number_of_axes,
        get_number_of_axes.
        """
    )

    def _end_angle_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetEndAngle,
                        self.end_angle)

    number_of_axes = traits.Trait(6, traits.Range(0, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the number of axis of the grid. Default is 6.
        """
    )

    def _number_of_axes_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfAxes,
                        self.number_of_axes)

    number_of_ticks = traits.Trait(6, traits.Range(2, 2147483647, enter_set=True, auto_set=False), desc=\
        r"""
        Set/Get the number of ticks for each axis. Default is 6.
        """
    )

    def _number_of_ticks_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetNumberOfTicks,
                        self.number_of_ticks)

    origin = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="float", value=(0.5, 0.5), cols=2, desc=\
        r"""
        Set/Get the origin (in normalized viewport coordinates) of the
        radial grid. Default is [0.5, 0.5]
        """
    )

    def _origin_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetOrigin,
                        self.origin)

    start_angle = traits.Float(0.0, enter_set=True, auto_set=False, desc=\
        r"""
        Set/Get the start angle (in degrees) of the radial grid. This is
        the orientation of the first axis, used as reference for the
        others. Default is 0.
        
        @see set_end_angle, get_end_angle, set_number_of_axes, get_number_of_axes
        """
    )

    def _start_angle_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetStartAngle,
                        self.start_angle)

    def _get_text_property(self):
        return wrap_vtk(self._vtk_obj.GetTextProperty())
    def _set_text_property(self, arg):
        old_val = self._get_text_property()
        self._wrap_call(self._vtk_obj.SetTextProperty,
                        deref_vtk(arg))
        self.trait_property_changed('text_property', old_val, arg)
    text_property = traits.Property(_get_text_property, _set_text_property, desc=\
        r"""
        
        """
    )

    def _get_first_axes_points(self):
        return wrap_vtk(self._vtk_obj.GetFirstAxesPoints())
    first_axes_points = traits.Property(_get_first_axes_points, desc=\
        r"""
        Get the first/last axes points.
        """
    )

    def _get_last_axes_points(self):
        return wrap_vtk(self._vtk_obj.GetLastAxesPoints())
    last_axes_points = traits.Property(_get_last_axes_points, desc=\
        r"""
        
        """
    )

    _updateable_traits_ = \
    (('dragable', 'GetDragable'), ('pickable', 'GetPickable'),
    ('use_bounds', 'GetUseBounds'), ('visibility', 'GetVisibility'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('axes_viewport_length',
    'GetAxesViewportLength'), ('end_angle', 'GetEndAngle'),
    ('number_of_axes', 'GetNumberOfAxes'), ('number_of_ticks',
    'GetNumberOfTicks'), ('origin', 'GetOrigin'), ('start_angle',
    'GetStartAngle'), ('height', 'GetHeight'), ('layer_number',
    'GetLayerNumber'), ('position', 'GetPosition'), ('position2',
    'GetPosition2'), ('width', 'GetWidth'), ('estimated_render_time',
    'GetEstimatedRenderTime'), ('render_time_multiplier',
    'GetRenderTimeMultiplier'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'dragable', 'global_warning_display', 'pickable',
    'use_bounds', 'visibility', 'axes_viewport_length', 'end_angle',
    'estimated_render_time', 'height', 'layer_number', 'number_of_axes',
    'number_of_ticks', 'object_name', 'origin', 'position', 'position2',
    'render_time_multiplier', 'start_angle', 'width'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(RadialGridActor2D, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit RadialGridActor2D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['use_bounds', 'visibility'], [], ['axes_viewport_length',
            'end_angle', 'estimated_render_time', 'height', 'layer_number',
            'number_of_axes', 'number_of_ticks', 'object_name', 'origin',
            'position', 'position2', 'render_time_multiplier', 'start_angle',
            'width']),
            title='Edit RadialGridActor2D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit RadialGridActor2D properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

