# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.data_set_algorithm import DataSetAlgorithm


class SpatioTemporalHarmonicsAttribute(DataSetAlgorithm):
    r"""
    SpatioTemporalHarmonicsAttribute - Computes spatio-temporal
    harmonics on each point.
    
    Superclass: DataSetAlgorithm
    
    SpatioTemporalHarmonicsAttribute is a filter that adds a data
    array storing spatio-temporal harmonics defined by the filter. Those
    harmonics are defined by their amplitude, temporal frequency, wave
    vector, and phase, with only a sinus function (no cosinus).
    
    Note that the data array generated is a DoubleArray that is set as
    the output SCALARS attribute.
    
    @sa SpatioTemporalHarmonicsSource
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkSpatioTemporalHarmonicsAttribute, obj, update, **traits)
    
    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    def add_harmonic(self, *args):
        """
        add_harmonic(self, amplitude:float, temporalFrequency:float,
            xWaveVector:float, yWaveVector:float, zWaveVector:float,
            phase:float) -> None
        C++: void add_harmonic(double amplitude, double temporalFrequency,
            double xWaveVector, double yWaveVector, double zWaveVector,
            double phase)
        Add an harmonic with all needed parameters.
        """
        ret = self._wrap_call(self._vtk_obj.AddHarmonic, *args)
        return ret

    def clear_harmonics(self):
        """
        clear_harmonics(self) -> None
        C++: void clear_harmonics()
        Clear all harmonics.
        """
        ret = self._vtk_obj.ClearHarmonics()
        return ret
        

    def compute_value(self, *args):
        """
        compute_value(self, coords:[float, float, float], time:float)
            -> float
        C++: double compute_value(double coords[3], double time)
        Compute spatio-temporal harmonic using filter-defined harmonics.
        """
        ret = self._wrap_call(self._vtk_obj.ComputeValue, *args)
        return ret

    def has_harmonics(self):
        """
        has_harmonics(self) -> bool
        C++: bool has_harmonics()
        Whether the filter has harmonics set, or is empty.
        """
        ret = self._vtk_obj.HasHarmonics()
        return ret
        

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('abort_output', 'GetAbortOutput'), ('progress_text',
    'GetProgressText'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(SpatioTemporalHarmonicsAttribute, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit SpatioTemporalHarmonicsAttribute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name']),
            title='Edit SpatioTemporalHarmonicsAttribute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit SpatioTemporalHarmonicsAttribute properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

