# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.image_algorithm import ImageAlgorithm


class SpatioTemporalHarmonicsSource(ImageAlgorithm):
    r"""
    SpatioTemporalHarmonicsSource - Creates a ImageData with
    harmonics data.
    
    Superclass: ImageAlgorithm
    
    SpatioTemporalHarmonicsSource creates a ImageData source that
    will have harmonics data on its points. It simply applies a
    SpatioTemporalHarmonicsAttributes on the generated image. It also
    allows generation of time steps.
    
    Note that default harmonics and time step values are set for common
    usage. Make sure to clear them before adding your own values.
    
    @sa ImageData SpatioTemporalHarmonicsAttribute
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkSpatioTemporalHarmonicsSource, obj, update, **traits)
    
    whole_extent = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(-10, 10, -10, 10, -10, 10), cols=3, desc=\
        r"""
        Set/Get the image extent. Default is (-10, 10, -10, 10, -10, 10).
        """
    )

    def _whole_extent_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetWholeExtent,
                        self.whole_extent)

    def _get_input(self):
        try:
            return wrap_vtk(self._vtk_obj.GetInput(0))
        except TypeError:
            return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input,
                            desc="The first input of this object, i.e. the result of `get_input(0)`.")
    
    def get_input(self, *args):
        """
        get_input(self, port:int) -> DataObject
        C++: DataObject *get_input(int port)
        get_input(self) -> DataObject
        C++: DataObject *get_input()
        Get a data object for one of the input port connections.  The use
        of this method is strongly discouraged, but some filters that
        were written a long time ago still use this method.
        """
        ret = self._wrap_call(self._vtk_obj.GetInput, *args)
        return wrap_vtk(ret)

    def add_harmonic(self, *args):
        """
        add_harmonic(self, amplitude:float, temporalFrequency:float,
            xWaveVector:float, yWaveVector:float, zWaveVector:float,
            phase:float) -> None
        C++: void add_harmonic(double amplitude, double temporalFrequency,
            double xWaveVector, double yWaveVector, double zWaveVector,
            double phase)
        Add an harmonic with all needed parameters. You may want to
        remove default harmonics first.
        """
        ret = self._wrap_call(self._vtk_obj.AddHarmonic, *args)
        return ret

    def add_time_step_value(self, *args):
        """
        add_time_step_value(self, timeStepValue:float) -> None
        C++: void add_time_step_value(double timeStepValue)
        Add a time step value. You may want to remove default values
        first.
        """
        ret = self._wrap_call(self._vtk_obj.AddTimeStepValue, *args)
        return ret

    def clear_harmonics(self):
        """
        clear_harmonics(self) -> None
        C++: void clear_harmonics()
        Clear all harmonics.
        """
        ret = self._vtk_obj.ClearHarmonics()
        return ret
        

    def clear_time_step_values(self):
        """
        clear_time_step_values(self) -> None
        C++: void clear_time_step_values()
        Clear time step values.
        """
        ret = self._vtk_obj.ClearTimeStepValues()
        return ret
        

    def reset_harmonics(self):
        """
        reset_harmonics(self) -> None
        C++: void reset_harmonics()
        Reset harmonics to default. By default, the source has harmonics
        in each direction, with phase shifts and different frequencies.
        The default wave vector is scaled to match default extent.
        """
        ret = self._vtk_obj.ResetHarmonics()
        return ret
        

    def reset_time_step_values(self):
        """
        reset_time_step_values(self) -> None
        C++: void reset_time_step_values()
        Reset time step values to default. By default, the source has 20
        time steps ranging from 0 to 2*PI. The default values allows an
        infinite loop of default harmonics.
        """
        ret = self._vtk_obj.ResetTimeStepValues()
        return ret
        

    _updateable_traits_ = \
    (('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('whole_extent', 'GetWholeExtent'), ('abort_output',
    'GetAbortOutput'), ('progress_text', 'GetProgressText'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'abort_output', 'object_name', 'progress_text',
    'whole_extent'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(SpatioTemporalHarmonicsSource, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit SpatioTemporalHarmonicsSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['abort_output', 'object_name', 'whole_extent']),
            title='Edit SpatioTemporalHarmonicsSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit SpatioTemporalHarmonicsSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

