# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.ghost_cells_generator import GhostCellsGenerator


class StitchImageDataWithGhosts(GhostCellsGenerator):
    r"""
    StitchImageDataWithGhosts - Stitches ImageData that are one
    voxel away
    
    Superclass: GhostCellsGenerator
    
    Given a set of `vtkimage_data` inputs, either across MPI ranks or
    within a `vtkcomposite_data_set`, this filter will stitch inputs that
    are spaced by one voxel. The inputs CANNOT have any `vtkcell_data`
    arrays, as the cells filling the gaps don't have any way to have
    values. As a consequence, if the input `vtkcell_data` is not empty,
    the filter will not run.
    
    Ghost points are set at the interfaces between the images, such that
    one and only one image has a non-ghost version of the point.
    
    One can optionally generate extra layers of ghost cells. If
    `number_of_ghost_layers` is set to 1, the images will be stitched. If it
    is set to n, the images will be stitched and have n - 1 layers of
    ghost cells.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkStitchImageDataWithGhosts, obj, update, **traits)
    
    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    _updateable_traits_ = \
    (('build_if_required', 'GetBuildIfRequired'), ('generate_global_ids',
    'GetGenerateGlobalIds'), ('generate_process_ids',
    'GetGenerateProcessIds'), ('synchronize_only', 'GetSynchronizeOnly'),
    ('use_static_mesh_cache', 'GetUseStaticMeshCache'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('number_of_ghost_layers',
    'GetNumberOfGhostLayers'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'build_if_required', 'debug',
    'generate_global_ids', 'generate_process_ids',
    'global_warning_display', 'release_data_flag', 'synchronize_only',
    'use_static_mesh_cache', 'abort_output', 'number_of_ghost_layers',
    'object_name', 'progress_text'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(StitchImageDataWithGhosts, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit StitchImageDataWithGhosts properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['build_if_required', 'generate_global_ids',
            'generate_process_ids', 'synchronize_only', 'use_static_mesh_cache'],
            [], ['abort_output', 'number_of_ghost_layers', 'object_name']),
            title='Edit StitchImageDataWithGhosts properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit StitchImageDataWithGhosts properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

