# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.pass_input_type_algorithm import PassInputTypeAlgorithm


class ToImplicitArrayFilter(PassInputTypeAlgorithm):
    r"""
    ToImplicitArrayFilter - A VTK filter for compressing explicit
    memory arrays into implicit arrays.
    
    Superclass: PassInputTypeAlgorithm
    
    The filter operates on arrays using strategies that inherit from
    `vtkto_implicit_strategy`. Arrays that are not compressed are shallow
    copied.
    
    Here is a code snippet using the filter considering that there is a
    `previousFilter` with an output data set that has a data array called
    "Constant" defined on its points: ``` NewtoImpArr; Newstrat;
    toimp_arr->set_strategy(strat);
    toimp_arr->set_input_connection(previousFilter->get_output_port()); auto
    select = toimp_arr->get_point_data_array_selection();
    select->enable_array("Constant"); toimp_arr->Update(); ```
    
    @sa
    ToImplicitStrategy, ImplicitArray
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkToImplicitArrayFilter, obj, update, **traits)
    
    use_max_number_of_degrees_of_freedom = tvtk_base.false_bool_trait(desc=\
        r"""
        
        """
    )

    def _use_max_number_of_degrees_of_freedom_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetUseMaxNumberOfDegreesOfFreedom,
                        self.use_max_number_of_degrees_of_freedom_)

    max_number_of_degrees_of_freedom = traits.Int(100, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _max_number_of_degrees_of_freedom_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetMaxNumberOfDegreesOfFreedom,
                        self.max_number_of_degrees_of_freedom)

    def _get_strategy(self):
        return wrap_vtk(self._vtk_obj.GetStrategy())
    def _set_strategy(self, arg):
        old_val = self._get_strategy()
        self._wrap_call(self._vtk_obj.SetStrategy,
                        deref_vtk(arg))
        self.trait_property_changed('strategy', old_val, arg)
    strategy = traits.Property(_get_strategy, _set_strategy, desc=\
        r"""
        
        """
    )

    target_reduction = traits.Float(0.1, enter_set=True, auto_set=False, desc=\
        r"""
        
        """
    )

    def _target_reduction_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTargetReduction,
                        self.target_reduction)

    def get_array_selection(self, *args):
        """
        get_array_selection(self, association:int) -> DataArraySelection
        C++: DataArraySelection *get_array_selection(int association)
        Methods for managing array selections
        """
        ret = self._wrap_call(self._vtk_obj.GetArraySelection, *args)
        return wrap_vtk(ret)

    def _get_cell_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetCellDataArraySelection())
    cell_data_array_selection = traits.Property(_get_cell_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_edge_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetEdgeDataArraySelection())
    edge_data_array_selection = traits.Property(_get_edge_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_field_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetFieldDataArraySelection())
    field_data_array_selection = traits.Property(_get_field_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, desc=\
        r"""
        Get the input data object. This method is not recommended for
        use, but lots of old style filters use it.
        """
    )

    def _get_point_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetPointDataArraySelection())
    point_data_array_selection = traits.Property(_get_point_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_points_then_cells_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetPointsThenCellsDataArraySelection())
    points_then_cells_data_array_selection = traits.Property(_get_points_then_cells_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_row_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetRowDataArraySelection())
    row_data_array_selection = traits.Property(_get_row_data_array_selection, desc=\
        r"""
        
        """
    )

    def _get_vertex_data_array_selection(self):
        return wrap_vtk(self._vtk_obj.GetVertexDataArraySelection())
    vertex_data_array_selection = traits.Property(_get_vertex_data_array_selection, desc=\
        r"""
        
        """
    )

    _updateable_traits_ = \
    (('use_max_number_of_degrees_of_freedom',
    'GetUseMaxNumberOfDegreesOfFreedom'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('max_number_of_degrees_of_freedom',
    'GetMaxNumberOfDegreesOfFreedom'), ('target_reduction',
    'GetTargetReduction'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'global_warning_display',
    'release_data_flag', 'use_max_number_of_degrees_of_freedom',
    'abort_output', 'max_number_of_degrees_of_freedom', 'object_name',
    'progress_text', 'target_reduction'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ToImplicitArrayFilter, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ToImplicitArrayFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['use_max_number_of_degrees_of_freedom'], [], ['abort_output',
            'max_number_of_degrees_of_freedom', 'object_name',
            'target_reduction']),
            title='Edit ToImplicitArrayFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ToImplicitArrayFilter properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

