# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.object import Object


class ToImplicitStrategy(Object):
    r"""
    ToImplicitStrategy - Pure interface for strategies to transform
    explicit arrays into implicit arrays.
    
    Superclass: Object
    
    The interface has two main components: an `estimate_reduction` method
    which estimates by how much this strategy can reduce the memory usage
    of the array and a `Reduce` method which returns a reduced array.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkToImplicitStrategy, obj, update, **traits)
    
    tolerance = traits.Float(0.001, enter_set=True, auto_set=False, desc=\
        r"""
        Getter/Setter for tolerance parameter
        
        This tolerance controls how close a compressed value needs to be
        to the actual value to be considered a match in absolute terms.
        
        Default value: 0.001
        """
    )

    def _tolerance_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetTolerance,
                        self.tolerance)

    def clear_cache(self):
        """
        clear_cache(self) -> None
        C++: virtual void clear_cache()
        Destroy any cached variables present in the object (useful for
        storing calculation results in-between the estimation and
        reduction phases).
        
        The default implementation does nothing.
        """
        ret = self._vtk_obj.ClearCache()
        return ret
        

    def reduce(self, *args):
        """
        reduce(self, __a:DataArray) -> DataArray
        C++: virtual SmartPointer<vtkDataArray> reduce(DataArray *)
        Return a reduced version of the input array
        """
        my_args = deref_array(args, [['vtkDataArray']])
        ret = self._wrap_call(self._vtk_obj.Reduce, *my_args)
        return wrap_vtk(ret)

    _updateable_traits_ = \
    (('debug', 'GetDebug'), ('global_warning_display',
    'GetGlobalWarningDisplay'), ('tolerance', 'GetTolerance'),
    ('object_name', 'GetObjectName'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'global_warning_display', 'object_name', 'tolerance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(ToImplicitStrategy, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit ToImplicitStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View(([], [], ['object_name', 'tolerance']),
            title='Edit ToImplicitStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit ToImplicitStrategy properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

