# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hyper_tree_grid_source import HyperTreeGridSource


class UniformHyperTreeGridSource(HyperTreeGridSource):
    r"""
    UniformHyperTreeGridSource - Create a synthetic grid of uniform
    hypertrees.
    
    Superclass: HyperTreeGridSource
    
    This class uses input parameters, most notably a string descriptor,
    to generate a HyperTreeGrid instance representing the
    corresponding tree-based AMR grid with uniform root cell sizes along
    each axis.
    
    @sa
    HyperTreeGridSource UniformHyperTreeGrid
    
    @par Thanks: This class was written by Philippe Pebay, nex_gen
    Analytics 2017 This work was supported by Commissariat a l'Energie
    Atomique (CEA/DIF) CEA, DAM, DIF, F-91297 Arpajon, France.
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkUniformHyperTreeGridSource, obj, update, **traits)
    
    _updateable_traits_ = \
    (('generate_interface_fields', 'GetGenerateInterfaceFields'),
    ('use_descriptor', 'GetUseDescriptor'), ('use_mask', 'GetUseMask'),
    ('abort_execute', 'GetAbortExecute'), ('release_data_flag',
    'GetReleaseDataFlag'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('branch_factor', 'GetBranchFactor'), ('descriptor', 'GetDescriptor'),
    ('dimensions', 'GetDimensions'), ('grid_scale', 'GetGridScale'),
    ('mask', 'GetMask'), ('max_depth', 'GetMaxDepth'), ('origin',
    'GetOrigin'), ('transposed_root_indexing',
    'GetTransposedRootIndexing'), ('abort_output', 'GetAbortOutput'),
    ('progress_text', 'GetProgressText'), ('object_name',
    'GetObjectName'), ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['abort_execute', 'debug', 'generate_interface_fields',
    'global_warning_display', 'release_data_flag', 'use_descriptor',
    'use_mask', 'abort_output', 'branch_factor', 'descriptor',
    'dimensions', 'grid_scale', 'mask', 'max_depth', 'object_name',
    'origin', 'progress_text', 'transposed_root_indexing'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(UniformHyperTreeGridSource, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit UniformHyperTreeGridSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['generate_interface_fields', 'use_descriptor', 'use_mask'], [],
            ['abort_output', 'branch_factor', 'descriptor', 'dimensions',
            'grid_scale', 'mask', 'max_depth', 'object_name', 'origin',
            'transposed_root_indexing']),
            title='Edit UniformHyperTreeGridSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit UniformHyperTreeGridSource properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

