# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk

nan = float('nan')


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.hardware_window import HardwareWindow


class Win32HardwareWindow(HardwareWindow):
    r"""
    Win32HardwareWindow - represents a window in a windows GUI
    
    Superclass: HardwareWindow
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkWin32HardwareWindow, obj, update, **traits)
    
    position = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(0, 0), cols=2, desc=\
        r"""
        Set the position of the window.
        """
    )

    def _position_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetPosition,
                        self.position)

    size = traits.Array(enter_set=True, auto_set=False, shape=(None,), dtype="int64", value=(0, 0), cols=2, desc=\
        r"""
        Set the size of the window in pixels.
        """
    )

    def _size_changed(self, old_val, new_val):
        self._do_change(self._vtk_obj.SetSize,
                        self.size)

    _updateable_traits_ = \
    (('double_buffer', 'GetDoubleBuffer'), ('erase', 'GetErase'),
    ('off_screen_rendering', 'GetOffScreenRendering'), ('show_window',
    'GetShowWindow'), ('use_off_screen_buffers',
    'GetUseOffScreenBuffers'), ('debug', 'GetDebug'),
    ('global_warning_display', 'GetGlobalWarningDisplay'), ('position',
    'GetPosition'), ('size', 'GetSize'), ('dpi', 'GetDPI'), ('tile_scale',
    'GetTileScale'), ('tile_viewport', 'GetTileViewport'), ('window_name',
    'GetWindowName'), ('object_name', 'GetObjectName'),
    ('reference_count', 'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['debug', 'double_buffer', 'erase', 'global_warning_display',
    'off_screen_rendering', 'show_window', 'use_off_screen_buffers',
    'dpi', 'object_name', 'position', 'size', 'tile_scale',
    'tile_viewport', 'window_name'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(Win32HardwareWindow, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit Win32HardwareWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['double_buffer', 'erase', 'off_screen_rendering',
            'show_window', 'use_off_screen_buffers'], [], ['dpi', 'object_name',
            'position', 'size', 'tile_scale', 'tile_viewport', 'window_name']),
            title='Edit Win32HardwareWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit Win32HardwareWindow properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

